#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 542
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 190
#define ALIAS_COUNT 0
#define TOKEN_COUNT 94
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 21
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 72

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_return = 3,
  anon_sym_SEMI = 4,
  anon_sym_EQ = 5,
  anon_sym_COMMA = 6,
  sym_break_statement = 7,
  anon_sym_do = 8,
  anon_sym_end = 9,
  anon_sym_while = 10,
  anon_sym_repeat = 11,
  anon_sym_until = 12,
  anon_sym_if = 13,
  anon_sym_then = 14,
  anon_sym_elseif = 15,
  anon_sym_else = 16,
  anon_sym_for = 17,
  anon_sym_in = 18,
  anon_sym_function = 19,
  anon_sym_local = 20,
  anon_sym_DOT = 21,
  anon_sym_COLON = 22,
  anon_sym_LT = 23,
  anon_sym_GT = 24,
  anon_sym_nil = 25,
  sym_false = 26,
  sym_true = 27,
  sym_number = 28,
  anon_sym_DQUOTE = 29,
  anon_sym_SQUOTE = 30,
  aux_sym__doublequote_string_content_token1 = 31,
  aux_sym__singlequote_string_content_token1 = 32,
  sym_escape_sequence = 33,
  sym_vararg_expression = 34,
  anon_sym_LPAREN = 35,
  anon_sym_RPAREN = 36,
  anon_sym_LBRACK = 37,
  anon_sym_RBRACK = 38,
  anon_sym_LBRACE = 39,
  anon_sym_RBRACE = 40,
  anon_sym_or = 41,
  anon_sym_and = 42,
  anon_sym_LT_EQ = 43,
  anon_sym_EQ_EQ = 44,
  anon_sym_TILDE_EQ = 45,
  anon_sym_GT_EQ = 46,
  anon_sym_PLUS = 47,
  anon_sym_DASH = 48,
  anon_sym_STAR = 49,
  anon_sym_SLASH = 50,
  anon_sym_SLASH_SLASH = 51,
  anon_sym_PERCENT = 52,
  anon_sym_DOT_DOT = 53,
  anon_sym_CARET = 54,
  anon_sym_not = 55,
  anon_sym_POUND = 56,
  anon_sym_DASH_DASH = 57,
  aux_sym_comment_token1 = 58,
  anon_sym_PLUS_EQ = 59,
  anon_sym_DASH_EQ = 60,
  anon_sym_STAR_EQ = 61,
  anon_sym_SLASH_EQ = 62,
  anon_sym_PERCENT_EQ = 63,
  anon_sym_CARET_EQ = 64,
  anon_sym_DOT_DOT_EQ = 65,
  sym_continue_statement = 66,
  anon_sym_export = 67,
  anon_sym_type = 68,
  anon_sym_typeof = 69,
  anon_sym_thread = 70,
  anon_sym_buffer = 71,
  anon_sym_any = 72,
  anon_sym_userdata = 73,
  anon_sym_unknown = 74,
  anon_sym_never = 75,
  anon_sym_string = 76,
  anon_sym_number = 77,
  anon_sym_table = 78,
  anon_sym_boolean = 79,
  anon_sym_DASH_GT = 80,
  anon_sym_PIPE = 81,
  anon_sym_QMARK = 82,
  anon_sym_COLON_COLON = 83,
  anon_sym_BQUOTE = 84,
  aux_sym__interpolation_string_content_token1 = 85,
  anon_sym_BSLASH_LBRACE = 86,
  aux_sym__escape_sequence_token1 = 87,
  sym__block_comment_start = 88,
  sym__block_comment_content = 89,
  sym__block_comment_end = 90,
  sym__block_string_start = 91,
  sym__block_string_content = 92,
  sym__block_string_end = 93,
  sym_chunk = 94,
  sym__block = 95,
  sym_statement = 96,
  sym_return_statement = 97,
  sym_empty_statement = 98,
  sym_assignment_statement = 99,
  sym__variable_assignment_varlist = 100,
  sym__variable_assignment_explist = 101,
  sym_do_statement = 102,
  sym_while_statement = 103,
  sym_repeat_statement = 104,
  sym_if_statement = 105,
  sym_elseif_statement = 106,
  sym_else_statement = 107,
  sym_for_statement = 108,
  sym_for_generic_clause = 109,
  sym_for_numeric_clause = 110,
  sym_declaration = 111,
  sym_function_declaration = 112,
  sym__local_function_declaration = 113,
  sym__function_name = 114,
  sym__function_name_prefix_expression = 115,
  sym__function_name_dot_index_expression = 116,
  sym__function_name_method_index_expression = 117,
  sym_variable_declaration = 118,
  sym__local_variable_assignment = 119,
  sym__name_list = 120,
  sym__att_name_list = 121,
  sym__attrib = 122,
  sym__expression_list = 123,
  sym_expression = 124,
  sym_nil = 125,
  sym_string = 126,
  sym__quote_string = 127,
  aux_sym__doublequote_string_content = 128,
  aux_sym__singlequote_string_content = 129,
  sym__block_string = 130,
  sym_function_definition = 131,
  sym__function_body = 132,
  sym_parameters = 133,
  sym__parameter_list = 134,
  sym__prefix_expression = 135,
  sym_variable = 136,
  sym_bracket_index_expression = 137,
  sym_dot_index_expression = 138,
  sym_function_call = 139,
  sym_method_index_expression = 140,
  sym_arguments = 141,
  sym_parenthesized_expression = 142,
  sym_table_constructor = 143,
  sym__field_list = 144,
  sym__field_sep = 145,
  sym_field = 146,
  sym_binary_expression = 147,
  sym_unary_expression = 148,
  sym_comment = 149,
  sym_update_statement = 150,
  sym_type_definition = 151,
  sym_generic_type_list = 152,
  sym_parameter = 153,
  sym_type = 154,
  sym_builtin_type = 155,
  sym_tuple_type = 156,
  sym_function_type = 157,
  sym_generic_type = 158,
  sym_object_type = 159,
  sym_empty_type = 160,
  sym_field_type = 161,
  sym_object_field_type = 162,
  sym_union_type = 163,
  sym_optional_type = 164,
  sym_literal_type = 165,
  sym_cast_expression = 166,
  sym_if_expression = 167,
  sym_elseif_clause = 168,
  sym_else_clause = 169,
  sym__interpolated_string = 170,
  sym__interpolation_string_content = 171,
  sym__escape_sequence = 172,
  sym_interpolation = 173,
  aux_sym_chunk_repeat1 = 174,
  aux_sym__variable_assignment_varlist_repeat1 = 175,
  aux_sym__variable_assignment_explist_repeat1 = 176,
  aux_sym_if_statement_repeat1 = 177,
  aux_sym__name_list_repeat1 = 178,
  aux_sym__att_name_list_repeat1 = 179,
  aux_sym__expression_list_repeat1 = 180,
  aux_sym__parameter_list_repeat1 = 181,
  aux_sym__field_list_repeat1 = 182,
  aux_sym_generic_type_list_repeat1 = 183,
  aux_sym_tuple_type_repeat1 = 184,
  aux_sym_function_type_repeat1 = 185,
  aux_sym_object_type_repeat1 = 186,
  aux_sym_field_type_repeat1 = 187,
  aux_sym_if_expression_repeat1 = 188,
  aux_sym__interpolated_string_repeat1 = 189,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_return] = "return",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [sym_break_statement] = "break_statement",
  [anon_sym_do] = "do",
  [anon_sym_end] = "end",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_until] = "until",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_function] = "function",
  [anon_sym_local] = "local",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON] = ":",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_nil] = "nil",
  [sym_false] = "false",
  [sym_true] = "true",
  [sym_number] = "number",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [aux_sym__doublequote_string_content_token1] = "_doublequote_string_content_token1",
  [aux_sym__singlequote_string_content_token1] = "_singlequote_string_content_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_vararg_expression] = "vararg_expression",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_CARET] = "^",
  [anon_sym_not] = "not",
  [anon_sym_POUND] = "#",
  [anon_sym_DASH_DASH] = "--",
  [aux_sym_comment_token1] = "comment_content",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [sym_continue_statement] = "continue_statement",
  [anon_sym_export] = "export",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_thread] = "thread",
  [anon_sym_buffer] = "buffer",
  [anon_sym_any] = "any",
  [anon_sym_userdata] = "userdata",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_string] = "string",
  [anon_sym_number] = "number",
  [anon_sym_table] = "table",
  [anon_sym_boolean] = "boolean",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_PIPE] = "|",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_BQUOTE] = "`",
  [aux_sym__interpolation_string_content_token1] = "_interpolation_string_content_token1",
  [anon_sym_BSLASH_LBRACE] = "\\{",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym__block_comment_start] = "[[",
  [sym__block_comment_content] = "comment_content",
  [sym__block_comment_end] = "]]",
  [sym__block_string_start] = "[[",
  [sym__block_string_content] = "string_content",
  [sym__block_string_end] = "]]",
  [sym_chunk] = "chunk",
  [sym__block] = "block",
  [sym_statement] = "statement",
  [sym_return_statement] = "return_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym__variable_assignment_varlist] = "variable_list",
  [sym__variable_assignment_explist] = "expression_list",
  [sym_do_statement] = "do_statement",
  [sym_while_statement] = "while_statement",
  [sym_repeat_statement] = "repeat_statement",
  [sym_if_statement] = "if_statement",
  [sym_elseif_statement] = "elseif_statement",
  [sym_else_statement] = "else_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_generic_clause] = "for_generic_clause",
  [sym_for_numeric_clause] = "for_numeric_clause",
  [sym_declaration] = "declaration",
  [sym_function_declaration] = "function_declaration",
  [sym__local_function_declaration] = "function_declaration",
  [sym__function_name] = "_function_name",
  [sym__function_name_prefix_expression] = "_function_name_prefix_expression",
  [sym__function_name_dot_index_expression] = "dot_index_expression",
  [sym__function_name_method_index_expression] = "method_index_expression",
  [sym_variable_declaration] = "variable_declaration",
  [sym__local_variable_assignment] = "assignment_statement",
  [sym__name_list] = "variable_list",
  [sym__att_name_list] = "variable_list",
  [sym__attrib] = "attribute",
  [sym__expression_list] = "expression_list",
  [sym_expression] = "expression",
  [sym_nil] = "nil",
  [sym_string] = "string",
  [sym__quote_string] = "_quote_string",
  [aux_sym__doublequote_string_content] = "_doublequote_string_content",
  [aux_sym__singlequote_string_content] = "_singlequote_string_content",
  [sym__block_string] = "_block_string",
  [sym_function_definition] = "function_definition",
  [sym__function_body] = "_function_body",
  [sym_parameters] = "parameters",
  [sym__parameter_list] = "_parameter_list",
  [sym__prefix_expression] = "_prefix_expression",
  [sym_variable] = "variable",
  [sym_bracket_index_expression] = "bracket_index_expression",
  [sym_dot_index_expression] = "dot_index_expression",
  [sym_function_call] = "function_call",
  [sym_method_index_expression] = "method_index_expression",
  [sym_arguments] = "arguments",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_table_constructor] = "table_constructor",
  [sym__field_list] = "_field_list",
  [sym__field_sep] = "_field_sep",
  [sym_field] = "field",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_comment] = "comment",
  [sym_update_statement] = "update_statement",
  [sym_type_definition] = "type_definition",
  [sym_generic_type_list] = "generic_type_list",
  [sym_parameter] = "parameter",
  [sym_type] = "type",
  [sym_builtin_type] = "builtin_type",
  [sym_tuple_type] = "tuple_type",
  [sym_function_type] = "function_type",
  [sym_generic_type] = "generic_type",
  [sym_object_type] = "object_type",
  [sym_empty_type] = "empty_type",
  [sym_field_type] = "field_type",
  [sym_object_field_type] = "object_field_type",
  [sym_union_type] = "union_type",
  [sym_optional_type] = "optional_type",
  [sym_literal_type] = "literal_type",
  [sym_cast_expression] = "cast_expression",
  [sym_if_expression] = "if_expression",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym__interpolated_string] = "_interpolated_string",
  [sym__interpolation_string_content] = "string_content",
  [sym__escape_sequence] = "_escape_sequence",
  [sym_interpolation] = "interpolation",
  [aux_sym_chunk_repeat1] = "chunk_repeat1",
  [aux_sym__variable_assignment_varlist_repeat1] = "_variable_assignment_varlist_repeat1",
  [aux_sym__variable_assignment_explist_repeat1] = "_variable_assignment_explist_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym__name_list_repeat1] = "_name_list_repeat1",
  [aux_sym__att_name_list_repeat1] = "_att_name_list_repeat1",
  [aux_sym__expression_list_repeat1] = "_expression_list_repeat1",
  [aux_sym__parameter_list_repeat1] = "_parameter_list_repeat1",
  [aux_sym__field_list_repeat1] = "_field_list_repeat1",
  [aux_sym_generic_type_list_repeat1] = "generic_type_list_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_function_type_repeat1] = "function_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_field_type_repeat1] = "field_type_repeat1",
  [aux_sym_if_expression_repeat1] = "if_expression_repeat1",
  [aux_sym__interpolated_string_repeat1] = "_interpolated_string_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_break_statement] = sym_break_statement,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_nil] = anon_sym_nil,
  [sym_false] = sym_false,
  [sym_true] = sym_true,
  [sym_number] = sym_number,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym__doublequote_string_content_token1] = aux_sym__doublequote_string_content_token1,
  [aux_sym__singlequote_string_content_token1] = aux_sym__singlequote_string_content_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_vararg_expression] = sym_vararg_expression,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [aux_sym_comment_token1] = sym__block_comment_content,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [sym_continue_statement] = sym_continue_statement,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_thread] = anon_sym_thread,
  [anon_sym_buffer] = anon_sym_buffer,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_userdata] = anon_sym_userdata,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_table] = anon_sym_table,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym__interpolation_string_content_token1] = aux_sym__interpolation_string_content_token1,
  [anon_sym_BSLASH_LBRACE] = anon_sym_BSLASH_LBRACE,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym__block_comment_start] = sym__block_comment_start,
  [sym__block_comment_content] = sym__block_comment_content,
  [sym__block_comment_end] = sym__block_comment_end,
  [sym__block_string_start] = sym__block_comment_start,
  [sym__block_string_content] = sym__block_string_content,
  [sym__block_string_end] = sym__block_comment_end,
  [sym_chunk] = sym_chunk,
  [sym__block] = sym__block,
  [sym_statement] = sym_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym__variable_assignment_varlist] = sym__variable_assignment_varlist,
  [sym__variable_assignment_explist] = sym__variable_assignment_explist,
  [sym_do_statement] = sym_do_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_statement] = sym_elseif_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_generic_clause] = sym_for_generic_clause,
  [sym_for_numeric_clause] = sym_for_numeric_clause,
  [sym_declaration] = sym_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym__local_function_declaration] = sym_function_declaration,
  [sym__function_name] = sym__function_name,
  [sym__function_name_prefix_expression] = sym__function_name_prefix_expression,
  [sym__function_name_dot_index_expression] = sym_dot_index_expression,
  [sym__function_name_method_index_expression] = sym_method_index_expression,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__local_variable_assignment] = sym_assignment_statement,
  [sym__name_list] = sym__variable_assignment_varlist,
  [sym__att_name_list] = sym__variable_assignment_varlist,
  [sym__attrib] = sym__attrib,
  [sym__expression_list] = sym__variable_assignment_explist,
  [sym_expression] = sym_expression,
  [sym_nil] = sym_nil,
  [sym_string] = sym_string,
  [sym__quote_string] = sym__quote_string,
  [aux_sym__doublequote_string_content] = aux_sym__doublequote_string_content,
  [aux_sym__singlequote_string_content] = aux_sym__singlequote_string_content,
  [sym__block_string] = sym__block_string,
  [sym_function_definition] = sym_function_definition,
  [sym__function_body] = sym__function_body,
  [sym_parameters] = sym_parameters,
  [sym__parameter_list] = sym__parameter_list,
  [sym__prefix_expression] = sym__prefix_expression,
  [sym_variable] = sym_variable,
  [sym_bracket_index_expression] = sym_bracket_index_expression,
  [sym_dot_index_expression] = sym_dot_index_expression,
  [sym_function_call] = sym_function_call,
  [sym_method_index_expression] = sym_method_index_expression,
  [sym_arguments] = sym_arguments,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_table_constructor] = sym_table_constructor,
  [sym__field_list] = sym__field_list,
  [sym__field_sep] = sym__field_sep,
  [sym_field] = sym_field,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_comment] = sym_comment,
  [sym_update_statement] = sym_update_statement,
  [sym_type_definition] = sym_type_definition,
  [sym_generic_type_list] = sym_generic_type_list,
  [sym_parameter] = sym_parameter,
  [sym_type] = sym_type,
  [sym_builtin_type] = sym_builtin_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_function_type] = sym_function_type,
  [sym_generic_type] = sym_generic_type,
  [sym_object_type] = sym_object_type,
  [sym_empty_type] = sym_empty_type,
  [sym_field_type] = sym_field_type,
  [sym_object_field_type] = sym_object_field_type,
  [sym_union_type] = sym_union_type,
  [sym_optional_type] = sym_optional_type,
  [sym_literal_type] = sym_literal_type,
  [sym_cast_expression] = sym_cast_expression,
  [sym_if_expression] = sym_if_expression,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym__interpolated_string] = sym__interpolated_string,
  [sym__interpolation_string_content] = sym__block_string_content,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym_interpolation] = sym_interpolation,
  [aux_sym_chunk_repeat1] = aux_sym_chunk_repeat1,
  [aux_sym__variable_assignment_varlist_repeat1] = aux_sym__variable_assignment_varlist_repeat1,
  [aux_sym__variable_assignment_explist_repeat1] = aux_sym__variable_assignment_explist_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym__name_list_repeat1] = aux_sym__name_list_repeat1,
  [aux_sym__att_name_list_repeat1] = aux_sym__att_name_list_repeat1,
  [aux_sym__expression_list_repeat1] = aux_sym__expression_list_repeat1,
  [aux_sym__parameter_list_repeat1] = aux_sym__parameter_list_repeat1,
  [aux_sym__field_list_repeat1] = aux_sym__field_list_repeat1,
  [aux_sym_generic_type_list_repeat1] = aux_sym_generic_type_list_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_function_type_repeat1] = aux_sym_function_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_field_type_repeat1] = aux_sym_field_type_repeat1,
  [aux_sym_if_expression_repeat1] = aux_sym_if_expression_repeat1,
  [aux_sym__interpolated_string_repeat1] = aux_sym__interpolated_string_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__doublequote_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__singlequote_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_vararg_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_buffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_userdata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_table] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpolation_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__block_comment_start] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_comment_end] = {
    .visible = true,
    .named = false,
  },
  [sym__block_string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__block_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_chunk] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_varlist] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_explist] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_generic_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_numeric_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__name_list] = {
    .visible = true,
    .named = true,
  },
  [sym__att_name_list] = {
    .visible = true,
    .named = true,
  },
  [sym__attrib] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__quote_string] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__doublequote_string_content] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__singlequote_string_content] = {
    .visible = false,
    .named = false,
  },
  [sym__block_string] = {
    .visible = false,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracket_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_table_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__field_list] = {
    .visible = false,
    .named = true,
  },
  [sym__field_sep] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_update_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_object_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolated_string] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolation_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_chunk_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_varlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_explist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__att_name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpolated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_arguments = 2,
  field_attribute = 3,
  field_body = 4,
  field_clause = 5,
  field_condition = 6,
  field_consequence = 7,
  field_content = 8,
  field_end = 9,
  field_field = 10,
  field_left = 11,
  field_local_declaration = 12,
  field_method = 13,
  field_name = 14,
  field_operand = 15,
  field_parameters = 16,
  field_right = 17,
  field_start = 18,
  field_step = 19,
  field_table = 20,
  field_value = 21,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_clause] = "clause",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_end] = "end",
  [field_field] = "field",
  [field_left] = "left",
  [field_local_declaration] = "local_declaration",
  [field_method] = "method",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_start] = "start",
  [field_step] = "step",
  [field_table] = "table",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 4},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 1},
  [5] = {.index = 7, .length = 2},
  [6] = {.index = 9, .length = 3},
  [7] = {.index = 12, .length = 1},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 2},
  [10] = {.index = 17, .length = 2},
  [11] = {.index = 19, .length = 2},
  [12] = {.index = 21, .length = 2},
  [13] = {.index = 23, .length = 3},
  [14] = {.index = 26, .length = 2},
  [15] = {.index = 28, .length = 2},
  [16] = {.index = 30, .length = 1},
  [17] = {.index = 31, .length = 1},
  [18] = {.index = 32, .length = 1},
  [19] = {.index = 33, .length = 1},
  [20] = {.index = 34, .length = 1},
  [21] = {.index = 35, .length = 3},
  [22] = {.index = 38, .length = 2},
  [23] = {.index = 40, .length = 3},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 2},
  [26] = {.index = 47, .length = 2},
  [27] = {.index = 49, .length = 1},
  [28] = {.index = 50, .length = 2},
  [29] = {.index = 52, .length = 1},
  [30] = {.index = 23, .length = 3},
  [31] = {.index = 53, .length = 1},
  [32] = {.index = 54, .length = 2},
  [33] = {.index = 56, .length = 2},
  [34] = {.index = 58, .length = 1},
  [35] = {.index = 59, .length = 2},
  [36] = {.index = 61, .length = 1},
  [37] = {.index = 62, .length = 1},
  [38] = {.index = 63, .length = 1},
  [39] = {.index = 64, .length = 3},
  [40] = {.index = 67, .length = 4},
  [41] = {.index = 71, .length = 4},
  [42] = {.index = 75, .length = 3},
  [43] = {.index = 78, .length = 2},
  [44] = {.index = 80, .length = 2},
  [45] = {.index = 82, .length = 2},
  [46] = {.index = 84, .length = 1},
  [47] = {.index = 85, .length = 2},
  [48] = {.index = 87, .length = 2},
  [49] = {.index = 89, .length = 2},
  [50] = {.index = 91, .length = 2},
  [51] = {.index = 93, .length = 2},
  [52] = {.index = 95, .length = 2},
  [53] = {.index = 97, .length = 2},
  [54] = {.index = 99, .length = 2},
  [55] = {.index = 101, .length = 3},
  [56] = {.index = 104, .length = 1},
  [57] = {.index = 105, .length = 1},
  [58] = {.index = 106, .length = 2},
  [59] = {.index = 108, .length = 2},
  [60] = {.index = 110, .length = 3},
  [61] = {.index = 113, .length = 3},
  [62] = {.index = 116, .length = 3},
  [63] = {.index = 119, .length = 3},
  [64] = {.index = 122, .length = 4},
  [65] = {.index = 126, .length = 1},
  [66] = {.index = 127, .length = 2},
  [67] = {.index = 129, .length = 2},
  [68] = {.index = 131, .length = 4},
  [69] = {.index = 135, .length = 2},
  [70] = {.index = 137, .length = 2},
  [71] = {.index = 139, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_local_declaration, 0, .inherited = true},
  [1] =
    {field_body, 0, .inherited = true},
    {field_local_declaration, 0},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [5] =
    {field_local_declaration, 0},
  [6] =
    {field_name, 0},
  [7] =
    {field_content, 1},
    {field_start, 0},
  [9] =
    {field_content, 0, .inherited = true},
    {field_end, 0, .inherited = true},
    {field_start, 0, .inherited = true},
  [12] =
    {field_content, 0, .inherited = true},
  [13] =
    {field_field, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [15] =
    {field_method, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [17] =
    {field_attribute, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [23] =
    {field_content, 1},
    {field_end, 2},
    {field_start, 0},
  [26] =
    {field_body, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [28] =
    {field_end, 1},
    {field_start, 0},
  [30] =
    {field_value, 0},
  [31] =
    {field_operand, 1},
  [32] =
    {field_content, 0},
  [33] =
    {field_body, 1},
  [34] =
    {field_condition, 2},
  [35] =
    {field_body, 2, .inherited = true},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
  [38] =
    {field_attribute, 1},
    {field_name, 0},
  [40] =
    {field_attribute, 1, .inherited = true},
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [43] =
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [45] =
    {field_field, 2},
    {field_table, 0},
  [47] =
    {field_method, 2},
    {field_table, 0},
  [49] =
    {field_name, 1},
  [50] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [52] =
    {field_parameters, 0},
  [53] =
    {field_content, 1, .inherited = true},
  [54] =
    {field_content, 0, .inherited = true},
    {field_content, 1, .inherited = true},
  [56] =
    {field_left, 0},
    {field_right, 2},
  [58] =
    {field_condition, 1},
  [59] =
    {field_body, 1},
    {field_condition, 3},
  [61] =
    {field_alternative, 0},
  [62] =
    {field_clause, 1},
  [63] =
    {field_name, 0, .inherited = true},
  [64] =
    {field_body, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
  [67] =
    {field_attribute, 1},
    {field_attribute, 2, .inherited = true},
    {field_name, 0},
    {field_name, 2, .inherited = true},
  [71] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [75] =
    {field_attribute, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [78] =
    {field_value, 0},
    {field_value, 1, .inherited = true},
  [80] =
    {field_condition, 1},
    {field_consequence, 3},
  [82] =
    {field_body, 1},
    {field_parameters, 0},
  [84] =
    {field_parameters, 1},
  [85] =
    {field_name, 0},
    {field_value, 2},
  [87] =
    {field_body, 3},
    {field_condition, 1},
  [89] =
    {field_alternative, 3},
    {field_condition, 1},
  [91] =
    {field_alternative, 3, .inherited = true},
    {field_condition, 1},
  [93] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [95] =
    {field_body, 3},
    {field_clause, 1},
  [97] =
    {field_attribute, 2},
    {field_name, 1},
  [99] =
    {field_attribute, 3},
    {field_name, 0},
  [101] =
    {field_attribute, 3, .inherited = true},
    {field_name, 0},
    {field_name, 3, .inherited = true},
  [104] =
    {field_name, 2},
  [105] =
    {field_value, 1},
  [106] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [108] =
    {field_body, 2},
    {field_parameters, 1},
  [110] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [113] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [116] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_condition, 1},
  [119] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
  [122] =
    {field_attribute, 3},
    {field_attribute, 4, .inherited = true},
    {field_name, 0},
    {field_name, 4, .inherited = true},
  [126] =
    {field_consequence, 1},
  [127] =
    {field_body, 3},
    {field_parameters, 0},
  [129] =
    {field_name, 1},
    {field_value, 4},
  [131] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [135] =
    {field_attribute, 4},
    {field_name, 1},
  [137] =
    {field_body, 4},
    {field_parameters, 1},
  [139] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
    {field_step, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [30] = {
    [1] = sym__block_string_content,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__doublequote_string_content, 2,
    aux_sym__doublequote_string_content,
    sym__block_string_content,
  aux_sym__singlequote_string_content, 2,
    aux_sym__singlequote_string_content,
    sym__block_string_content,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 14,
  [31] = 31,
  [32] = 17,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 15,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 16,
  [50] = 50,
  [51] = 51,
  [52] = 18,
  [53] = 19,
  [54] = 20,
  [55] = 6,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 21,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 12,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 103,
  [107] = 69,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 127,
  [129] = 115,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 162,
  [167] = 132,
  [168] = 168,
  [169] = 144,
  [170] = 170,
  [171] = 160,
  [172] = 131,
  [173] = 141,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 184,
  [197] = 197,
  [198] = 188,
  [199] = 176,
  [200] = 182,
  [201] = 185,
  [202] = 189,
  [203] = 190,
  [204] = 193,
  [205] = 175,
  [206] = 195,
  [207] = 177,
  [208] = 186,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 293,
  [298] = 298,
  [299] = 293,
  [300] = 295,
  [301] = 301,
  [302] = 295,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 309,
  [311] = 306,
  [312] = 22,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 23,
  [319] = 319,
  [320] = 320,
  [321] = 24,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 25,
  [340] = 340,
  [341] = 341,
  [342] = 27,
  [343] = 28,
  [344] = 29,
  [345] = 345,
  [346] = 346,
  [347] = 328,
  [348] = 329,
  [349] = 334,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 331,
  [354] = 351,
  [355] = 333,
  [356] = 338,
  [357] = 326,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 42,
  [370] = 56,
  [371] = 58,
  [372] = 372,
  [373] = 35,
  [374] = 374,
  [375] = 375,
  [376] = 57,
  [377] = 59,
  [378] = 378,
  [379] = 31,
  [380] = 380,
  [381] = 34,
  [382] = 352,
  [383] = 36,
  [384] = 37,
  [385] = 40,
  [386] = 386,
  [387] = 41,
  [388] = 60,
  [389] = 43,
  [390] = 44,
  [391] = 45,
  [392] = 46,
  [393] = 47,
  [394] = 394,
  [395] = 48,
  [396] = 50,
  [397] = 51,
  [398] = 14,
  [399] = 15,
  [400] = 16,
  [401] = 17,
  [402] = 18,
  [403] = 19,
  [404] = 20,
  [405] = 6,
  [406] = 360,
  [407] = 361,
  [408] = 365,
  [409] = 358,
  [410] = 359,
  [411] = 363,
  [412] = 360,
  [413] = 361,
  [414] = 365,
  [415] = 358,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 419,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 425,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 416,
  [446] = 440,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 442,
  [452] = 447,
  [453] = 453,
  [454] = 430,
  [455] = 437,
  [456] = 448,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 487,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 501,
  [504] = 504,
  [505] = 504,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 498,
  [511] = 511,
  [512] = 512,
  [513] = 490,
  [514] = 514,
  [515] = 515,
  [516] = 487,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 517,
  [521] = 521,
  [522] = 511,
  [523] = 494,
  [524] = 524,
  [525] = 508,
  [526] = 526,
  [527] = 496,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 512,
  [532] = 532,
  [533] = 533,
  [534] = 517,
  [535] = 535,
  [536] = 481,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '"', 61,
        '#', 100,
        '%', 95,
        '\'', 62,
        '(', 74,
        ')', 75,
        '*', 90,
        '+', 85,
        ',', 42,
        '-', 87,
        '.', 44,
        '/', 92,
        '0', 53,
        ':', 48,
        ';', 39,
        '<', 50,
        '=', 41,
        '>', 52,
        '?', 116,
        '[', 76,
        '\\', 15,
        ']', 77,
        '^', 99,
        '`', 118,
        '{', 78,
        '|', 115,
        '}', 79,
        '~', 13,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(54);
      if (lookahead > ' ' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(101);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '"', 61,
        '%', 8,
        '\'', 62,
        '(', 74,
        '*', 9,
        '+', 10,
        ',', 42,
        '-', 4,
        '.', 46,
        '/', 11,
        ':', 47,
        '<', 49,
        '=', 40,
        '>', 51,
        '?', 116,
        '[', 76,
        '^', 12,
        '`', 118,
        '{', 78,
        '|', 115,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '-') ADVANCE(64);
      if (lookahead == '\\') ADVANCE(16);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(63);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 3:
      if (lookahead == '\'') ADVANCE(62);
      if (lookahead == '-') ADVANCE(67);
      if (lookahead == '\\') ADVANCE(16);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(66);
      if (lookahead != 0) ADVANCE(68);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 5:
      if (lookahead == '-') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == '`') ADVANCE(118);
      if (lookahead == '{') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(119);
      if (lookahead != 0) ADVANCE(121);
      END_STATE();
    case 6:
      if (lookahead == '.') ADVANCE(7);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 7:
      if (lookahead == '.') ADVANCE(73);
      END_STATE();
    case 8:
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 9:
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 10:
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 11:
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(82);
      END_STATE();
    case 14:
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 15:
      if (lookahead == 'U') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'x') ADVANCE(28);
      if (lookahead == '{') ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(71);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(69);
      if (lookahead != 0) ADVANCE(69);
      END_STATE();
    case 16:
      if (lookahead == 'U') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'x') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(71);
      if (lookahead != 0) ADVANCE(69);
      END_STATE();
    case 17:
      if (lookahead == '{') ADVANCE(122);
      END_STATE();
    case 18:
      if (lookahead == '{') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 19:
      if (lookahead == '}') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 21:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(59);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 28:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(23);
      END_STATE();
    case 29:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 30:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(29);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(30);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 33:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '"', 61,
        '#', 100,
        '%', 95,
        '\'', 62,
        '(', 74,
        ')', 75,
        '*', 90,
        '+', 85,
        ',', 42,
        '-', 87,
        '.', 44,
        '/', 92,
        '0', 53,
        ':', 48,
        ';', 39,
        '<', 50,
        '=', 41,
        '>', 52,
        '?', 116,
        '[', 76,
        '\\', 17,
        ']', 77,
        '^', 99,
        '`', 118,
        '{', 78,
        '|', 115,
        '}', 79,
        '~', 13,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(54);
      if (lookahead > ' ' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(101);
      END_STATE();
    case 34:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '"', 61,
        '#', 100,
        '\'', 62,
        '(', 74,
        ')', 75,
        ',', 42,
        '-', 88,
        '.', 6,
        '0', 53,
        ';', 39,
        '>', 51,
        '?', 116,
        '[', 76,
        '`', 118,
        '{', 78,
        '|', 115,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(54);
      if (lookahead > ' ' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(101);
      END_STATE();
    case 35:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '"', 61,
        '#', 38,
        '%', 95,
        '\'', 62,
        '(', 74,
        ')', 75,
        '*', 90,
        '+', 85,
        ',', 42,
        '-', 86,
        '.', 43,
        '/', 92,
        ':', 48,
        ';', 39,
        '<', 50,
        '=', 41,
        '>', 52,
        '?', 116,
        '[', 76,
        ']', 77,
        '^', 99,
        '`', 118,
        '{', 78,
        '|', 115,
        '}', 79,
        '~', 13,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (lookahead > ' ' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(101);
      END_STATE();
    case 36:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '"', 61,
        '%', 94,
        '\'', 62,
        '(', 74,
        ')', 75,
        '*', 89,
        '+', 84,
        ',', 42,
        '-', 88,
        '.', 45,
        '/', 91,
        ':', 48,
        ';', 39,
        '<', 50,
        '=', 41,
        '>', 52,
        '?', 116,
        '[', 76,
        ']', 77,
        '^', 98,
        '`', 118,
        '{', 78,
        '|', 115,
        '}', 79,
        '~', 13,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(101);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(81);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(97);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(96);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(14);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(117);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(80);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(56);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(21);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(56);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(54);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(57);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead == '-') ADVANCE(64);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(65);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead == '-') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead == '-') ADVANCE(67);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(68);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead == '-') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(68);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(68);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(69);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(70);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(32);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_vararg_expression);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(114);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '>') ADVANCE(114);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(93);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(101);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(106);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(104);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(106);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(106);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(106);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead == '-') ADVANCE(120);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(119);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(121);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(121);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_BSLASH_LBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'i', 7,
        'l', 8,
        'n', 9,
        'o', 10,
        'r', 11,
        's', 12,
        't', 13,
        'u', 14,
        'w', 15,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(20);
      END_STATE();
    case 4:
      if (lookahead == 'o') ADVANCE(21);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 'x') ADVANCE(24);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'u') ADVANCE(27);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(29);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'i') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(35);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 12:
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'h') ADVANCE(39);
      if (lookahead == 'r') ADVANCE(40);
      if (lookahead == 'y') ADVANCE(41);
      END_STATE();
    case 14:
      if (lookahead == 'n') ADVANCE(42);
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(44);
      END_STATE();
    case 16:
      if (lookahead == 'd') ADVANCE(45);
      if (lookahead == 'y') ADVANCE(46);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(47);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 19:
      if (lookahead == 'f') ADVANCE(49);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(51);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(52);
      END_STATE();
    case 24:
      if (lookahead == 'p') ADVANCE(53);
      END_STATE();
    case 25:
      if (lookahead == 'l') ADVANCE(54);
      END_STATE();
    case 26:
      if (lookahead == 'r') ADVANCE(55);
      END_STATE();
    case 27:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 30:
      if (lookahead == 'c') ADVANCE(57);
      END_STATE();
    case 31:
      if (lookahead == 'v') ADVANCE(58);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(59);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(61);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(62);
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 38:
      if (lookahead == 'b') ADVANCE(65);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 40:
      if (lookahead == 'u') ADVANCE(68);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 42:
      if (lookahead == 'k') ADVANCE(70);
      if (lookahead == 't') ADVANCE(71);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 49:
      if (lookahead == 'f') ADVANCE(76);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 53:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 56:
      if (lookahead == 'c') ADVANCE(81);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 61:
      if (lookahead == 'b') ADVANCE(84);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(87);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 66:
      if (lookahead == 'n') ADVANCE(89);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 72:
      if (lookahead == 'r') ADVANCE(95);
      END_STATE();
    case 73:
      if (lookahead == 'l') ADVANCE(96);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 75:
      if (lookahead == 'k') ADVANCE(98);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(100);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(101);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(102);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(105);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(108);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(109);
      END_STATE();
    case 87:
      if (lookahead == 'n') ADVANCE(110);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(112);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(113);
      END_STATE();
    case 93:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 94:
      if (lookahead == 'l') ADVANCE(115);
      END_STATE();
    case 95:
      if (lookahead == 'd') ADVANCE(116);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(118);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 99:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 100:
      if (lookahead == 'n') ADVANCE(120);
      END_STATE();
    case 101:
      if (lookahead == 'f') ADVANCE(121);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 104:
      if (lookahead == 'i') ADVANCE(123);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 109:
      if (lookahead == 'n') ADVANCE(126);
      END_STATE();
    case 110:
      if (lookahead == 'g') ADVANCE(127);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_table);
      END_STATE();
    case 112:
      if (lookahead == 'd') ADVANCE(128);
      END_STATE();
    case 113:
      if (lookahead == 'f') ADVANCE(129);
      END_STATE();
    case 114:
      if (lookahead == 'w') ADVANCE(130);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 118:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_buffer);
      END_STATE();
    case 120:
      if (lookahead == 'u') ADVANCE(133);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(134);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_thread);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 134:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 136:
      if (lookahead == 'a') ADVANCE(139);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_continue_statement);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_userdata);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 35, .external_lex_state = 2},
  [2] = {.lex_state = 35, .external_lex_state = 3},
  [3] = {.lex_state = 35, .external_lex_state = 3},
  [4] = {.lex_state = 35, .external_lex_state = 3},
  [5] = {.lex_state = 36, .external_lex_state = 3},
  [6] = {.lex_state = 36, .external_lex_state = 3},
  [7] = {.lex_state = 36, .external_lex_state = 3},
  [8] = {.lex_state = 36, .external_lex_state = 3},
  [9] = {.lex_state = 36, .external_lex_state = 3},
  [10] = {.lex_state = 36, .external_lex_state = 3},
  [11] = {.lex_state = 36, .external_lex_state = 3},
  [12] = {.lex_state = 36, .external_lex_state = 3},
  [13] = {.lex_state = 36, .external_lex_state = 3},
  [14] = {.lex_state = 36, .external_lex_state = 3},
  [15] = {.lex_state = 36, .external_lex_state = 3},
  [16] = {.lex_state = 36, .external_lex_state = 3},
  [17] = {.lex_state = 36, .external_lex_state = 3},
  [18] = {.lex_state = 36, .external_lex_state = 3},
  [19] = {.lex_state = 36, .external_lex_state = 3},
  [20] = {.lex_state = 36, .external_lex_state = 3},
  [21] = {.lex_state = 36, .external_lex_state = 3},
  [22] = {.lex_state = 36, .external_lex_state = 2},
  [23] = {.lex_state = 36, .external_lex_state = 2},
  [24] = {.lex_state = 36, .external_lex_state = 2},
  [25] = {.lex_state = 36, .external_lex_state = 2},
  [26] = {.lex_state = 0, .external_lex_state = 2},
  [27] = {.lex_state = 36, .external_lex_state = 2},
  [28] = {.lex_state = 36, .external_lex_state = 2},
  [29] = {.lex_state = 36, .external_lex_state = 2},
  [30] = {.lex_state = 36, .external_lex_state = 2},
  [31] = {.lex_state = 36, .external_lex_state = 2},
  [32] = {.lex_state = 36, .external_lex_state = 2},
  [33] = {.lex_state = 36, .external_lex_state = 2},
  [34] = {.lex_state = 36, .external_lex_state = 2},
  [35] = {.lex_state = 36, .external_lex_state = 2},
  [36] = {.lex_state = 36, .external_lex_state = 2},
  [37] = {.lex_state = 36, .external_lex_state = 2},
  [38] = {.lex_state = 36, .external_lex_state = 2},
  [39] = {.lex_state = 36, .external_lex_state = 2},
  [40] = {.lex_state = 36, .external_lex_state = 2},
  [41] = {.lex_state = 36, .external_lex_state = 2},
  [42] = {.lex_state = 36, .external_lex_state = 2},
  [43] = {.lex_state = 36, .external_lex_state = 2},
  [44] = {.lex_state = 36, .external_lex_state = 2},
  [45] = {.lex_state = 36, .external_lex_state = 2},
  [46] = {.lex_state = 36, .external_lex_state = 2},
  [47] = {.lex_state = 36, .external_lex_state = 2},
  [48] = {.lex_state = 36, .external_lex_state = 2},
  [49] = {.lex_state = 36, .external_lex_state = 2},
  [50] = {.lex_state = 36, .external_lex_state = 2},
  [51] = {.lex_state = 36, .external_lex_state = 2},
  [52] = {.lex_state = 36, .external_lex_state = 2},
  [53] = {.lex_state = 36, .external_lex_state = 2},
  [54] = {.lex_state = 36, .external_lex_state = 2},
  [55] = {.lex_state = 36, .external_lex_state = 2},
  [56] = {.lex_state = 36, .external_lex_state = 2},
  [57] = {.lex_state = 36, .external_lex_state = 2},
  [58] = {.lex_state = 36, .external_lex_state = 2},
  [59] = {.lex_state = 36, .external_lex_state = 2},
  [60] = {.lex_state = 36, .external_lex_state = 2},
  [61] = {.lex_state = 36, .external_lex_state = 2},
  [62] = {.lex_state = 36, .external_lex_state = 2},
  [63] = {.lex_state = 0, .external_lex_state = 2},
  [64] = {.lex_state = 0, .external_lex_state = 2},
  [65] = {.lex_state = 0, .external_lex_state = 2},
  [66] = {.lex_state = 0, .external_lex_state = 2},
  [67] = {.lex_state = 0, .external_lex_state = 2},
  [68] = {.lex_state = 36, .external_lex_state = 2},
  [69] = {.lex_state = 34, .external_lex_state = 3},
  [70] = {.lex_state = 36, .external_lex_state = 2},
  [71] = {.lex_state = 0, .external_lex_state = 2},
  [72] = {.lex_state = 36, .external_lex_state = 2},
  [73] = {.lex_state = 36, .external_lex_state = 2},
  [74] = {.lex_state = 36, .external_lex_state = 2},
  [75] = {.lex_state = 36, .external_lex_state = 2},
  [76] = {.lex_state = 36, .external_lex_state = 2},
  [77] = {.lex_state = 36, .external_lex_state = 2},
  [78] = {.lex_state = 36, .external_lex_state = 2},
  [79] = {.lex_state = 36, .external_lex_state = 2},
  [80] = {.lex_state = 36, .external_lex_state = 2},
  [81] = {.lex_state = 36, .external_lex_state = 2},
  [82] = {.lex_state = 36, .external_lex_state = 2},
  [83] = {.lex_state = 0, .external_lex_state = 2},
  [84] = {.lex_state = 36, .external_lex_state = 2},
  [85] = {.lex_state = 36, .external_lex_state = 2},
  [86] = {.lex_state = 36, .external_lex_state = 2},
  [87] = {.lex_state = 36, .external_lex_state = 2},
  [88] = {.lex_state = 36, .external_lex_state = 2},
  [89] = {.lex_state = 36, .external_lex_state = 2},
  [90] = {.lex_state = 36, .external_lex_state = 2},
  [91] = {.lex_state = 36, .external_lex_state = 2},
  [92] = {.lex_state = 36, .external_lex_state = 2},
  [93] = {.lex_state = 36, .external_lex_state = 2},
  [94] = {.lex_state = 36, .external_lex_state = 2},
  [95] = {.lex_state = 36, .external_lex_state = 2},
  [96] = {.lex_state = 36, .external_lex_state = 2},
  [97] = {.lex_state = 0, .external_lex_state = 2},
  [98] = {.lex_state = 0, .external_lex_state = 2},
  [99] = {.lex_state = 0, .external_lex_state = 2},
  [100] = {.lex_state = 0, .external_lex_state = 2},
  [101] = {.lex_state = 0, .external_lex_state = 2},
  [102] = {.lex_state = 0, .external_lex_state = 2},
  [103] = {.lex_state = 34, .external_lex_state = 3},
  [104] = {.lex_state = 0, .external_lex_state = 2},
  [105] = {.lex_state = 0, .external_lex_state = 2},
  [106] = {.lex_state = 34, .external_lex_state = 3},
  [107] = {.lex_state = 34, .external_lex_state = 3},
  [108] = {.lex_state = 34, .external_lex_state = 3},
  [109] = {.lex_state = 36, .external_lex_state = 2},
  [110] = {.lex_state = 34, .external_lex_state = 3},
  [111] = {.lex_state = 36, .external_lex_state = 2},
  [112] = {.lex_state = 34, .external_lex_state = 3},
  [113] = {.lex_state = 34, .external_lex_state = 3},
  [114] = {.lex_state = 36, .external_lex_state = 2},
  [115] = {.lex_state = 0, .external_lex_state = 3},
  [116] = {.lex_state = 34, .external_lex_state = 3},
  [117] = {.lex_state = 34, .external_lex_state = 3},
  [118] = {.lex_state = 34, .external_lex_state = 3},
  [119] = {.lex_state = 34, .external_lex_state = 3},
  [120] = {.lex_state = 34, .external_lex_state = 3},
  [121] = {.lex_state = 34, .external_lex_state = 3},
  [122] = {.lex_state = 34, .external_lex_state = 3},
  [123] = {.lex_state = 36, .external_lex_state = 2},
  [124] = {.lex_state = 34, .external_lex_state = 3},
  [125] = {.lex_state = 34, .external_lex_state = 3},
  [126] = {.lex_state = 34, .external_lex_state = 3},
  [127] = {.lex_state = 0, .external_lex_state = 3},
  [128] = {.lex_state = 0, .external_lex_state = 3},
  [129] = {.lex_state = 0, .external_lex_state = 3},
  [130] = {.lex_state = 34, .external_lex_state = 3},
  [131] = {.lex_state = 0, .external_lex_state = 3},
  [132] = {.lex_state = 0, .external_lex_state = 3},
  [133] = {.lex_state = 34, .external_lex_state = 3},
  [134] = {.lex_state = 34, .external_lex_state = 3},
  [135] = {.lex_state = 34, .external_lex_state = 3},
  [136] = {.lex_state = 34, .external_lex_state = 3},
  [137] = {.lex_state = 34, .external_lex_state = 3},
  [138] = {.lex_state = 34, .external_lex_state = 3},
  [139] = {.lex_state = 34, .external_lex_state = 3},
  [140] = {.lex_state = 34, .external_lex_state = 3},
  [141] = {.lex_state = 0, .external_lex_state = 3},
  [142] = {.lex_state = 34, .external_lex_state = 3},
  [143] = {.lex_state = 34, .external_lex_state = 3},
  [144] = {.lex_state = 0, .external_lex_state = 3},
  [145] = {.lex_state = 34, .external_lex_state = 3},
  [146] = {.lex_state = 34, .external_lex_state = 3},
  [147] = {.lex_state = 34, .external_lex_state = 3},
  [148] = {.lex_state = 34, .external_lex_state = 3},
  [149] = {.lex_state = 34, .external_lex_state = 3},
  [150] = {.lex_state = 34, .external_lex_state = 3},
  [151] = {.lex_state = 34, .external_lex_state = 3},
  [152] = {.lex_state = 34, .external_lex_state = 3},
  [153] = {.lex_state = 34, .external_lex_state = 3},
  [154] = {.lex_state = 34, .external_lex_state = 3},
  [155] = {.lex_state = 34, .external_lex_state = 3},
  [156] = {.lex_state = 34, .external_lex_state = 3},
  [157] = {.lex_state = 0, .external_lex_state = 3},
  [158] = {.lex_state = 34, .external_lex_state = 3},
  [159] = {.lex_state = 34, .external_lex_state = 3},
  [160] = {.lex_state = 0, .external_lex_state = 3},
  [161] = {.lex_state = 34, .external_lex_state = 3},
  [162] = {.lex_state = 34, .external_lex_state = 3},
  [163] = {.lex_state = 34, .external_lex_state = 3},
  [164] = {.lex_state = 34, .external_lex_state = 3},
  [165] = {.lex_state = 34, .external_lex_state = 3},
  [166] = {.lex_state = 34, .external_lex_state = 3},
  [167] = {.lex_state = 0, .external_lex_state = 3},
  [168] = {.lex_state = 0, .external_lex_state = 3},
  [169] = {.lex_state = 0, .external_lex_state = 3},
  [170] = {.lex_state = 34, .external_lex_state = 3},
  [171] = {.lex_state = 0, .external_lex_state = 3},
  [172] = {.lex_state = 0, .external_lex_state = 3},
  [173] = {.lex_state = 0, .external_lex_state = 3},
  [174] = {.lex_state = 34, .external_lex_state = 3},
  [175] = {.lex_state = 0, .external_lex_state = 3},
  [176] = {.lex_state = 0, .external_lex_state = 3},
  [177] = {.lex_state = 0, .external_lex_state = 3},
  [178] = {.lex_state = 0, .external_lex_state = 3},
  [179] = {.lex_state = 0, .external_lex_state = 3},
  [180] = {.lex_state = 0, .external_lex_state = 3},
  [181] = {.lex_state = 0, .external_lex_state = 3},
  [182] = {.lex_state = 0, .external_lex_state = 3},
  [183] = {.lex_state = 0, .external_lex_state = 3},
  [184] = {.lex_state = 0, .external_lex_state = 3},
  [185] = {.lex_state = 0, .external_lex_state = 3},
  [186] = {.lex_state = 0, .external_lex_state = 3},
  [187] = {.lex_state = 0, .external_lex_state = 3},
  [188] = {.lex_state = 0, .external_lex_state = 3},
  [189] = {.lex_state = 0, .external_lex_state = 3},
  [190] = {.lex_state = 0, .external_lex_state = 3},
  [191] = {.lex_state = 0, .external_lex_state = 3},
  [192] = {.lex_state = 0, .external_lex_state = 3},
  [193] = {.lex_state = 0, .external_lex_state = 3},
  [194] = {.lex_state = 0, .external_lex_state = 3},
  [195] = {.lex_state = 0, .external_lex_state = 3},
  [196] = {.lex_state = 0, .external_lex_state = 3},
  [197] = {.lex_state = 0, .external_lex_state = 3},
  [198] = {.lex_state = 0, .external_lex_state = 3},
  [199] = {.lex_state = 0, .external_lex_state = 3},
  [200] = {.lex_state = 0, .external_lex_state = 3},
  [201] = {.lex_state = 0, .external_lex_state = 3},
  [202] = {.lex_state = 0, .external_lex_state = 3},
  [203] = {.lex_state = 0, .external_lex_state = 3},
  [204] = {.lex_state = 0, .external_lex_state = 3},
  [205] = {.lex_state = 0, .external_lex_state = 3},
  [206] = {.lex_state = 0, .external_lex_state = 3},
  [207] = {.lex_state = 0, .external_lex_state = 3},
  [208] = {.lex_state = 0, .external_lex_state = 3},
  [209] = {.lex_state = 0, .external_lex_state = 3},
  [210] = {.lex_state = 36, .external_lex_state = 3},
  [211] = {.lex_state = 35, .external_lex_state = 3},
  [212] = {.lex_state = 0, .external_lex_state = 2},
  [213] = {.lex_state = 36, .external_lex_state = 2},
  [214] = {.lex_state = 0, .external_lex_state = 2},
  [215] = {.lex_state = 36, .external_lex_state = 2},
  [216] = {.lex_state = 0, .external_lex_state = 2},
  [217] = {.lex_state = 0, .external_lex_state = 2},
  [218] = {.lex_state = 0, .external_lex_state = 2},
  [219] = {.lex_state = 0, .external_lex_state = 2},
  [220] = {.lex_state = 0, .external_lex_state = 2},
  [221] = {.lex_state = 0, .external_lex_state = 2},
  [222] = {.lex_state = 0, .external_lex_state = 2},
  [223] = {.lex_state = 0, .external_lex_state = 2},
  [224] = {.lex_state = 0, .external_lex_state = 2},
  [225] = {.lex_state = 0, .external_lex_state = 2},
  [226] = {.lex_state = 0, .external_lex_state = 2},
  [227] = {.lex_state = 0, .external_lex_state = 2},
  [228] = {.lex_state = 0, .external_lex_state = 2},
  [229] = {.lex_state = 0, .external_lex_state = 2},
  [230] = {.lex_state = 0, .external_lex_state = 2},
  [231] = {.lex_state = 0, .external_lex_state = 2},
  [232] = {.lex_state = 0, .external_lex_state = 2},
  [233] = {.lex_state = 36, .external_lex_state = 2},
  [234] = {.lex_state = 0, .external_lex_state = 2},
  [235] = {.lex_state = 0, .external_lex_state = 2},
  [236] = {.lex_state = 0, .external_lex_state = 2},
  [237] = {.lex_state = 0, .external_lex_state = 2},
  [238] = {.lex_state = 0, .external_lex_state = 2},
  [239] = {.lex_state = 36, .external_lex_state = 2},
  [240] = {.lex_state = 0, .external_lex_state = 2},
  [241] = {.lex_state = 36, .external_lex_state = 2},
  [242] = {.lex_state = 0, .external_lex_state = 2},
  [243] = {.lex_state = 0, .external_lex_state = 2},
  [244] = {.lex_state = 0, .external_lex_state = 2},
  [245] = {.lex_state = 0, .external_lex_state = 2},
  [246] = {.lex_state = 0, .external_lex_state = 2},
  [247] = {.lex_state = 0, .external_lex_state = 2},
  [248] = {.lex_state = 0, .external_lex_state = 2},
  [249] = {.lex_state = 0, .external_lex_state = 2},
  [250] = {.lex_state = 0, .external_lex_state = 2},
  [251] = {.lex_state = 0, .external_lex_state = 2},
  [252] = {.lex_state = 0, .external_lex_state = 2},
  [253] = {.lex_state = 0, .external_lex_state = 2},
  [254] = {.lex_state = 0, .external_lex_state = 2},
  [255] = {.lex_state = 0, .external_lex_state = 2},
  [256] = {.lex_state = 0, .external_lex_state = 2},
  [257] = {.lex_state = 0, .external_lex_state = 2},
  [258] = {.lex_state = 0, .external_lex_state = 2},
  [259] = {.lex_state = 36, .external_lex_state = 2},
  [260] = {.lex_state = 0, .external_lex_state = 2},
  [261] = {.lex_state = 0, .external_lex_state = 2},
  [262] = {.lex_state = 0, .external_lex_state = 2},
  [263] = {.lex_state = 0, .external_lex_state = 2},
  [264] = {.lex_state = 0, .external_lex_state = 2},
  [265] = {.lex_state = 0, .external_lex_state = 2},
  [266] = {.lex_state = 0, .external_lex_state = 2},
  [267] = {.lex_state = 0, .external_lex_state = 2},
  [268] = {.lex_state = 0, .external_lex_state = 2},
  [269] = {.lex_state = 0, .external_lex_state = 2},
  [270] = {.lex_state = 0, .external_lex_state = 2},
  [271] = {.lex_state = 0, .external_lex_state = 2},
  [272] = {.lex_state = 1, .external_lex_state = 3},
  [273] = {.lex_state = 36, .external_lex_state = 2},
  [274] = {.lex_state = 34, .external_lex_state = 3},
  [275] = {.lex_state = 36, .external_lex_state = 2},
  [276] = {.lex_state = 36, .external_lex_state = 2},
  [277] = {.lex_state = 36, .external_lex_state = 2},
  [278] = {.lex_state = 36, .external_lex_state = 2},
  [279] = {.lex_state = 36, .external_lex_state = 2},
  [280] = {.lex_state = 36, .external_lex_state = 2},
  [281] = {.lex_state = 36, .external_lex_state = 2},
  [282] = {.lex_state = 1, .external_lex_state = 3},
  [283] = {.lex_state = 36, .external_lex_state = 2},
  [284] = {.lex_state = 36, .external_lex_state = 2},
  [285] = {.lex_state = 36, .external_lex_state = 2},
  [286] = {.lex_state = 36, .external_lex_state = 2},
  [287] = {.lex_state = 36, .external_lex_state = 2},
  [288] = {.lex_state = 36, .external_lex_state = 2},
  [289] = {.lex_state = 0, .external_lex_state = 2},
  [290] = {.lex_state = 0, .external_lex_state = 2},
  [291] = {.lex_state = 35, .external_lex_state = 3},
  [292] = {.lex_state = 0, .external_lex_state = 3},
  [293] = {.lex_state = 5, .external_lex_state = 2},
  [294] = {.lex_state = 0, .external_lex_state = 2},
  [295] = {.lex_state = 5, .external_lex_state = 2},
  [296] = {.lex_state = 1, .external_lex_state = 2},
  [297] = {.lex_state = 5, .external_lex_state = 2},
  [298] = {.lex_state = 5, .external_lex_state = 2},
  [299] = {.lex_state = 5, .external_lex_state = 2},
  [300] = {.lex_state = 5, .external_lex_state = 2},
  [301] = {.lex_state = 1, .external_lex_state = 2},
  [302] = {.lex_state = 5, .external_lex_state = 2},
  [303] = {.lex_state = 0, .external_lex_state = 2},
  [304] = {.lex_state = 0, .external_lex_state = 2},
  [305] = {.lex_state = 35, .external_lex_state = 3},
  [306] = {.lex_state = 35, .external_lex_state = 2},
  [307] = {.lex_state = 1, .external_lex_state = 2},
  [308] = {.lex_state = 35, .external_lex_state = 2},
  [309] = {.lex_state = 35, .external_lex_state = 2},
  [310] = {.lex_state = 35, .external_lex_state = 2},
  [311] = {.lex_state = 35, .external_lex_state = 2},
  [312] = {.lex_state = 1, .external_lex_state = 2},
  [313] = {.lex_state = 5, .external_lex_state = 2},
  [314] = {.lex_state = 0, .external_lex_state = 3},
  [315] = {.lex_state = 0, .external_lex_state = 2},
  [316] = {.lex_state = 0, .external_lex_state = 2},
  [317] = {.lex_state = 0, .external_lex_state = 2},
  [318] = {.lex_state = 1, .external_lex_state = 2},
  [319] = {.lex_state = 5, .external_lex_state = 2},
  [320] = {.lex_state = 0, .external_lex_state = 2},
  [321] = {.lex_state = 1, .external_lex_state = 2},
  [322] = {.lex_state = 5, .external_lex_state = 2},
  [323] = {.lex_state = 5, .external_lex_state = 2},
  [324] = {.lex_state = 5, .external_lex_state = 2},
  [325] = {.lex_state = 5, .external_lex_state = 2},
  [326] = {.lex_state = 0, .external_lex_state = 2},
  [327] = {.lex_state = 0, .external_lex_state = 2},
  [328] = {.lex_state = 0, .external_lex_state = 2},
  [329] = {.lex_state = 0, .external_lex_state = 2},
  [330] = {.lex_state = 0, .external_lex_state = 2},
  [331] = {.lex_state = 0, .external_lex_state = 2},
  [332] = {.lex_state = 0, .external_lex_state = 2},
  [333] = {.lex_state = 0, .external_lex_state = 2},
  [334] = {.lex_state = 34, .external_lex_state = 2},
  [335] = {.lex_state = 0, .external_lex_state = 2},
  [336] = {.lex_state = 0, .external_lex_state = 2},
  [337] = {.lex_state = 0, .external_lex_state = 2},
  [338] = {.lex_state = 0, .external_lex_state = 2},
  [339] = {.lex_state = 34, .external_lex_state = 2},
  [340] = {.lex_state = 0, .external_lex_state = 2},
  [341] = {.lex_state = 0, .external_lex_state = 2},
  [342] = {.lex_state = 34, .external_lex_state = 2},
  [343] = {.lex_state = 1, .external_lex_state = 2},
  [344] = {.lex_state = 34, .external_lex_state = 2},
  [345] = {.lex_state = 0, .external_lex_state = 2},
  [346] = {.lex_state = 0, .external_lex_state = 2},
  [347] = {.lex_state = 0, .external_lex_state = 2},
  [348] = {.lex_state = 0, .external_lex_state = 2},
  [349] = {.lex_state = 34, .external_lex_state = 2},
  [350] = {.lex_state = 34, .external_lex_state = 2},
  [351] = {.lex_state = 0, .external_lex_state = 2},
  [352] = {.lex_state = 0, .external_lex_state = 2},
  [353] = {.lex_state = 0, .external_lex_state = 2},
  [354] = {.lex_state = 0, .external_lex_state = 2},
  [355] = {.lex_state = 0, .external_lex_state = 2},
  [356] = {.lex_state = 0, .external_lex_state = 2},
  [357] = {.lex_state = 0, .external_lex_state = 2},
  [358] = {.lex_state = 3, .external_lex_state = 2},
  [359] = {.lex_state = 0, .external_lex_state = 2},
  [360] = {.lex_state = 2, .external_lex_state = 2},
  [361] = {.lex_state = 3, .external_lex_state = 2},
  [362] = {.lex_state = 0, .external_lex_state = 2},
  [363] = {.lex_state = 0, .external_lex_state = 2},
  [364] = {.lex_state = 0, .external_lex_state = 2},
  [365] = {.lex_state = 2, .external_lex_state = 2},
  [366] = {.lex_state = 0, .external_lex_state = 2},
  [367] = {.lex_state = 0, .external_lex_state = 2},
  [368] = {.lex_state = 0, .external_lex_state = 2},
  [369] = {.lex_state = 34, .external_lex_state = 2},
  [370] = {.lex_state = 34, .external_lex_state = 2},
  [371] = {.lex_state = 34, .external_lex_state = 2},
  [372] = {.lex_state = 0, .external_lex_state = 2},
  [373] = {.lex_state = 34, .external_lex_state = 2},
  [374] = {.lex_state = 35, .external_lex_state = 2},
  [375] = {.lex_state = 0, .external_lex_state = 2},
  [376] = {.lex_state = 34, .external_lex_state = 2},
  [377] = {.lex_state = 34, .external_lex_state = 2},
  [378] = {.lex_state = 2, .external_lex_state = 2},
  [379] = {.lex_state = 34, .external_lex_state = 2},
  [380] = {.lex_state = 3, .external_lex_state = 2},
  [381] = {.lex_state = 34, .external_lex_state = 2},
  [382] = {.lex_state = 34, .external_lex_state = 2},
  [383] = {.lex_state = 34, .external_lex_state = 2},
  [384] = {.lex_state = 34, .external_lex_state = 2},
  [385] = {.lex_state = 34, .external_lex_state = 2},
  [386] = {.lex_state = 0, .external_lex_state = 2},
  [387] = {.lex_state = 34, .external_lex_state = 2},
  [388] = {.lex_state = 34, .external_lex_state = 2},
  [389] = {.lex_state = 34, .external_lex_state = 2},
  [390] = {.lex_state = 34, .external_lex_state = 2},
  [391] = {.lex_state = 34, .external_lex_state = 2},
  [392] = {.lex_state = 34, .external_lex_state = 2},
  [393] = {.lex_state = 34, .external_lex_state = 2},
  [394] = {.lex_state = 35, .external_lex_state = 2},
  [395] = {.lex_state = 34, .external_lex_state = 2},
  [396] = {.lex_state = 34, .external_lex_state = 2},
  [397] = {.lex_state = 34, .external_lex_state = 2},
  [398] = {.lex_state = 34, .external_lex_state = 2},
  [399] = {.lex_state = 34, .external_lex_state = 2},
  [400] = {.lex_state = 34, .external_lex_state = 2},
  [401] = {.lex_state = 34, .external_lex_state = 2},
  [402] = {.lex_state = 34, .external_lex_state = 2},
  [403] = {.lex_state = 34, .external_lex_state = 2},
  [404] = {.lex_state = 34, .external_lex_state = 2},
  [405] = {.lex_state = 34, .external_lex_state = 2},
  [406] = {.lex_state = 2, .external_lex_state = 2},
  [407] = {.lex_state = 3, .external_lex_state = 2},
  [408] = {.lex_state = 2, .external_lex_state = 2},
  [409] = {.lex_state = 3, .external_lex_state = 2},
  [410] = {.lex_state = 0, .external_lex_state = 2},
  [411] = {.lex_state = 0, .external_lex_state = 2},
  [412] = {.lex_state = 2, .external_lex_state = 2},
  [413] = {.lex_state = 3, .external_lex_state = 2},
  [414] = {.lex_state = 2, .external_lex_state = 2},
  [415] = {.lex_state = 3, .external_lex_state = 2},
  [416] = {.lex_state = 0, .external_lex_state = 2},
  [417] = {.lex_state = 35, .external_lex_state = 2},
  [418] = {.lex_state = 35, .external_lex_state = 2},
  [419] = {.lex_state = 0, .external_lex_state = 2},
  [420] = {.lex_state = 34, .external_lex_state = 2},
  [421] = {.lex_state = 0, .external_lex_state = 2},
  [422] = {.lex_state = 0, .external_lex_state = 2},
  [423] = {.lex_state = 3, .external_lex_state = 2},
  [424] = {.lex_state = 0, .external_lex_state = 2},
  [425] = {.lex_state = 0, .external_lex_state = 2},
  [426] = {.lex_state = 0, .external_lex_state = 2},
  [427] = {.lex_state = 0, .external_lex_state = 2},
  [428] = {.lex_state = 0, .external_lex_state = 2},
  [429] = {.lex_state = 34, .external_lex_state = 2},
  [430] = {.lex_state = 0, .external_lex_state = 2},
  [431] = {.lex_state = 0, .external_lex_state = 2},
  [432] = {.lex_state = 0, .external_lex_state = 2},
  [433] = {.lex_state = 2, .external_lex_state = 2},
  [434] = {.lex_state = 34, .external_lex_state = 2},
  [435] = {.lex_state = 0, .external_lex_state = 2},
  [436] = {.lex_state = 0, .external_lex_state = 2},
  [437] = {.lex_state = 0, .external_lex_state = 2},
  [438] = {.lex_state = 0, .external_lex_state = 2},
  [439] = {.lex_state = 0, .external_lex_state = 2},
  [440] = {.lex_state = 0, .external_lex_state = 2},
  [441] = {.lex_state = 0, .external_lex_state = 2},
  [442] = {.lex_state = 34, .external_lex_state = 2},
  [443] = {.lex_state = 0, .external_lex_state = 2},
  [444] = {.lex_state = 0, .external_lex_state = 2},
  [445] = {.lex_state = 34, .external_lex_state = 2},
  [446] = {.lex_state = 0, .external_lex_state = 2},
  [447] = {.lex_state = 0, .external_lex_state = 2},
  [448] = {.lex_state = 0, .external_lex_state = 2},
  [449] = {.lex_state = 0, .external_lex_state = 2},
  [450] = {.lex_state = 0, .external_lex_state = 2},
  [451] = {.lex_state = 34, .external_lex_state = 2},
  [452] = {.lex_state = 0, .external_lex_state = 2},
  [453] = {.lex_state = 34, .external_lex_state = 2},
  [454] = {.lex_state = 0, .external_lex_state = 2},
  [455] = {.lex_state = 0, .external_lex_state = 2},
  [456] = {.lex_state = 0, .external_lex_state = 2},
  [457] = {.lex_state = 0, .external_lex_state = 2},
  [458] = {.lex_state = 34, .external_lex_state = 2},
  [459] = {.lex_state = 0, .external_lex_state = 2},
  [460] = {.lex_state = 0, .external_lex_state = 2},
  [461] = {.lex_state = 0, .external_lex_state = 2},
  [462] = {.lex_state = 34, .external_lex_state = 2},
  [463] = {.lex_state = 0, .external_lex_state = 2},
  [464] = {.lex_state = 0, .external_lex_state = 2},
  [465] = {.lex_state = 0, .external_lex_state = 2},
  [466] = {.lex_state = 0, .external_lex_state = 2},
  [467] = {.lex_state = 0, .external_lex_state = 2},
  [468] = {.lex_state = 0, .external_lex_state = 2},
  [469] = {.lex_state = 0, .external_lex_state = 2},
  [470] = {.lex_state = 0, .external_lex_state = 2},
  [471] = {.lex_state = 0, .external_lex_state = 2},
  [472] = {.lex_state = 34, .external_lex_state = 2},
  [473] = {.lex_state = 0, .external_lex_state = 2},
  [474] = {.lex_state = 0, .external_lex_state = 4},
  [475] = {.lex_state = 0, .external_lex_state = 2},
  [476] = {.lex_state = 0, .external_lex_state = 2},
  [477] = {.lex_state = 0, .external_lex_state = 2},
  [478] = {.lex_state = 0, .external_lex_state = 2},
  [479] = {.lex_state = 0, .external_lex_state = 2},
  [480] = {.lex_state = 0, .external_lex_state = 2},
  [481] = {.lex_state = 0, .external_lex_state = 2},
  [482] = {.lex_state = 0, .external_lex_state = 2},
  [483] = {.lex_state = 0, .external_lex_state = 2},
  [484] = {.lex_state = 0, .external_lex_state = 2},
  [485] = {.lex_state = 0, .external_lex_state = 2},
  [486] = {.lex_state = 0, .external_lex_state = 2},
  [487] = {.lex_state = 0, .external_lex_state = 5},
  [488] = {.lex_state = 0, .external_lex_state = 2},
  [489] = {.lex_state = 0, .external_lex_state = 2},
  [490] = {.lex_state = 0, .external_lex_state = 2},
  [491] = {.lex_state = 0, .external_lex_state = 5},
  [492] = {.lex_state = 0, .external_lex_state = 2},
  [493] = {.lex_state = 0, .external_lex_state = 2},
  [494] = {.lex_state = 0, .external_lex_state = 2},
  [495] = {.lex_state = 0, .external_lex_state = 2},
  [496] = {.lex_state = 0, .external_lex_state = 2},
  [497] = {.lex_state = 0, .external_lex_state = 2},
  [498] = {.lex_state = 0, .external_lex_state = 2},
  [499] = {.lex_state = 0, .external_lex_state = 6},
  [500] = {.lex_state = 0, .external_lex_state = 2},
  [501] = {.lex_state = 0, .external_lex_state = 2},
  [502] = {.lex_state = 0, .external_lex_state = 2},
  [503] = {.lex_state = 0, .external_lex_state = 2},
  [504] = {.lex_state = 0, .external_lex_state = 2},
  [505] = {.lex_state = 0, .external_lex_state = 2},
  [506] = {.lex_state = 0, .external_lex_state = 2},
  [507] = {.lex_state = 104, .external_lex_state = 2},
  [508] = {.lex_state = 0, .external_lex_state = 2},
  [509] = {.lex_state = 0, .external_lex_state = 2},
  [510] = {.lex_state = 0, .external_lex_state = 2},
  [511] = {.lex_state = 0, .external_lex_state = 2},
  [512] = {.lex_state = 0, .external_lex_state = 2},
  [513] = {.lex_state = 0, .external_lex_state = 2},
  [514] = {.lex_state = 0, .external_lex_state = 2},
  [515] = {.lex_state = 0, .external_lex_state = 2},
  [516] = {.lex_state = 0, .external_lex_state = 5},
  [517] = {.lex_state = 0, .external_lex_state = 7},
  [518] = {.lex_state = 0, .external_lex_state = 2},
  [519] = {.lex_state = 0, .external_lex_state = 2},
  [520] = {.lex_state = 0, .external_lex_state = 7},
  [521] = {.lex_state = 0, .external_lex_state = 2},
  [522] = {.lex_state = 0, .external_lex_state = 2},
  [523] = {.lex_state = 0, .external_lex_state = 2},
  [524] = {.lex_state = 0, .external_lex_state = 2},
  [525] = {.lex_state = 0, .external_lex_state = 2},
  [526] = {.lex_state = 0, .external_lex_state = 2},
  [527] = {.lex_state = 0, .external_lex_state = 2},
  [528] = {.lex_state = 0, .external_lex_state = 2},
  [529] = {.lex_state = 0, .external_lex_state = 2},
  [530] = {.lex_state = 0, .external_lex_state = 2},
  [531] = {.lex_state = 0, .external_lex_state = 2},
  [532] = {.lex_state = 0, .external_lex_state = 2},
  [533] = {.lex_state = 0, .external_lex_state = 2},
  [534] = {.lex_state = 0, .external_lex_state = 7},
  [535] = {.lex_state = 0, .external_lex_state = 2},
  [536] = {.lex_state = 0, .external_lex_state = 2},
  [537] = {.lex_state = 0, .external_lex_state = 2},
  [538] = {.lex_state = 0, .external_lex_state = 2},
  [539] = {.lex_state = 0, .external_lex_state = 2},
  [540] = {(TSStateId)(-1)},
  [541] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [sym_continue_statement] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_thread] = ACTIONS(1),
    [anon_sym_buffer] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_userdata] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_table] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_LBRACE] = ACTIONS(1),
    [aux_sym__escape_sequence_token1] = ACTIONS(1),
    [sym__block_comment_start] = ACTIONS(5),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__block_comment_end] = ACTIONS(1),
    [sym__block_string_start] = ACTIONS(1),
    [sym__block_string_content] = ACTIONS(1),
    [sym__block_string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_chunk] = STATE(482),
    [sym_statement] = STATE(252),
    [sym_return_statement] = STATE(521),
    [sym_empty_statement] = STATE(251),
    [sym_assignment_statement] = STATE(251),
    [sym__variable_assignment_varlist] = STATE(307),
    [sym_do_statement] = STATE(251),
    [sym_while_statement] = STATE(251),
    [sym_repeat_statement] = STATE(251),
    [sym_if_statement] = STATE(251),
    [sym_for_statement] = STATE(251),
    [sym_declaration] = STATE(253),
    [sym_function_declaration] = STATE(254),
    [sym__local_function_declaration] = STATE(250),
    [sym_variable_declaration] = STATE(271),
    [sym__prefix_expression] = STATE(291),
    [sym_variable] = STATE(272),
    [sym_bracket_index_expression] = STATE(2),
    [sym_dot_index_expression] = STATE(2),
    [sym_function_call] = STATE(211),
    [sym_method_index_expression] = STATE(292),
    [sym_parenthesized_expression] = STATE(305),
    [sym_comment] = STATE(1),
    [sym_update_statement] = STATE(251),
    [sym_type_definition] = STATE(251),
    [aux_sym_chunk_repeat1] = STATE(104),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [sym_hash_bang_line] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [sym_break_statement] = ACTIONS(17),
    [anon_sym_do] = ACTIONS(19),
    [anon_sym_while] = ACTIONS(21),
    [anon_sym_repeat] = ACTIONS(23),
    [anon_sym_if] = ACTIONS(25),
    [anon_sym_for] = ACTIONS(27),
    [anon_sym_function] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [sym_continue_statement] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(35),
    [anon_sym_type] = ACTIONS(37),
    [sym__block_comment_start] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(2), 1,
      sym_comment,
    ACTIONS(39), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(41), 32,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [72] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(3), 1,
      sym_comment,
    ACTIONS(43), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(45), 32,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [144] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(4), 1,
      sym_comment,
    ACTIONS(47), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(49), 32,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [216] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(5), 1,
      sym_comment,
    ACTIONS(55), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(57), 7,
      sym__block_string_start,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(51), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(53), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [284] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(6), 1,
      sym_comment,
    ACTIONS(59), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(61), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [348] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(7), 1,
      sym_comment,
    ACTIONS(63), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(65), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [412] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(8), 1,
      sym_comment,
    ACTIONS(67), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(69), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [476] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(9), 1,
      sym_comment,
    ACTIONS(71), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(73), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [540] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(10), 1,
      sym_comment,
    ACTIONS(75), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(77), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [604] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(11), 1,
      sym_comment,
    ACTIONS(79), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(81), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [668] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(12), 1,
      sym_comment,
    ACTIONS(83), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(85), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [732] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(13), 1,
      sym_comment,
    ACTIONS(87), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(89), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [796] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(14), 1,
      sym_comment,
    ACTIONS(91), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(93), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [860] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(15), 1,
      sym_comment,
    ACTIONS(91), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(93), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [924] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(16), 1,
      sym_comment,
    ACTIONS(95), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(97), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [988] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(17), 1,
      sym_comment,
    ACTIONS(99), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(101), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1052] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(18), 1,
      sym_comment,
    ACTIONS(103), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(105), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1116] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(19), 1,
      sym_comment,
    ACTIONS(107), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(109), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1180] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(20), 1,
      sym_comment,
    ACTIONS(111), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(113), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1244] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(21), 1,
      sym_comment,
    ACTIONS(115), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(117), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1308] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(123), 1,
      anon_sym_DOT,
    ACTIONS(125), 1,
      anon_sym_LT,
    STATE(22), 1,
      sym_comment,
    STATE(23), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(119), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(121), 24,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1375] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(123), 1,
      anon_sym_DOT,
    STATE(23), 1,
      sym_comment,
    STATE(24), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(127), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(129), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1440] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(135), 1,
      anon_sym_DOT,
    STATE(24), 2,
      sym_comment,
      aux_sym_field_type_repeat1,
    ACTIONS(131), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(133), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1503] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(142), 1,
      anon_sym_DASH_GT,
    STATE(25), 1,
      sym_comment,
    ACTIONS(138), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(140), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1565] = 39,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(146), 1,
      anon_sym_end,
    ACTIONS(148), 1,
      anon_sym_elseif,
    ACTIONS(150), 1,
      anon_sym_else,
    STATE(26), 1,
      sym_comment,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(316), 1,
      sym__block,
    STATE(320), 1,
      aux_sym_if_statement_repeat1,
    STATE(362), 1,
      sym_return_statement,
    STATE(439), 1,
      sym_elseif_statement,
    STATE(500), 1,
      sym_else_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [1693] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(156), 1,
      anon_sym_DASH_GT,
    STATE(27), 1,
      sym_comment,
    ACTIONS(152), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(154), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1755] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(28), 1,
      sym_comment,
    ACTIONS(131), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(133), 26,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1815] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(162), 1,
      anon_sym_DASH_GT,
    STATE(29), 1,
      sym_comment,
    ACTIONS(158), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(160), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1877] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(30), 1,
      sym_comment,
    ACTIONS(91), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(93), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1936] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(31), 1,
      sym_comment,
    ACTIONS(164), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(166), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1995] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(32), 1,
      sym_comment,
    ACTIONS(99), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(101), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2054] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_elseif,
    ACTIONS(174), 1,
      anon_sym_else,
    ACTIONS(178), 1,
      anon_sym_or,
    ACTIONS(180), 1,
      anon_sym_and,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(33), 1,
      sym_comment,
    STATE(39), 1,
      aux_sym_if_expression_repeat1,
    STATE(84), 1,
      sym_elseif_clause,
    STATE(85), 1,
      sym_else_clause,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(168), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(170), 16,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2145] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(34), 1,
      sym_comment,
    ACTIONS(198), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(200), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2208] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(35), 1,
      sym_comment,
    ACTIONS(206), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(208), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2267] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(36), 1,
      sym_comment,
    ACTIONS(210), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(212), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2326] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(37), 1,
      sym_comment,
    ACTIONS(214), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(216), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2385] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(38), 1,
      sym_comment,
    ACTIONS(91), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(93), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2444] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_elseif,
    ACTIONS(174), 1,
      anon_sym_else,
    STATE(39), 1,
      sym_comment,
    STATE(62), 1,
      aux_sym_if_expression_repeat1,
    STATE(84), 1,
      sym_elseif_clause,
    STATE(91), 1,
      sym_else_clause,
    ACTIONS(218), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(220), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2513] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(40), 1,
      sym_comment,
    ACTIONS(222), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(224), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2576] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(41), 1,
      sym_comment,
    ACTIONS(226), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(228), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2635] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(42), 1,
      sym_comment,
    ACTIONS(230), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(232), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2694] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(43), 1,
      sym_comment,
    ACTIONS(234), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(236), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2757] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(44), 1,
      sym_comment,
    ACTIONS(238), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(240), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2816] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(45), 1,
      sym_comment,
    ACTIONS(242), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(244), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2879] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(46), 1,
      sym_comment,
    ACTIONS(246), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(248), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2938] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(47), 1,
      sym_comment,
    ACTIONS(250), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(252), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3001] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(48), 1,
      sym_comment,
    ACTIONS(254), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(256), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3064] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(49), 1,
      sym_comment,
    ACTIONS(95), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(97), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3123] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(50), 1,
      sym_comment,
    ACTIONS(258), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(260), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3186] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(51), 1,
      sym_comment,
    ACTIONS(262), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(264), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3249] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(52), 1,
      sym_comment,
    ACTIONS(103), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(105), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3308] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(53), 1,
      sym_comment,
    ACTIONS(107), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(109), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3367] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(54), 1,
      sym_comment,
    ACTIONS(111), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(113), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3426] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(55), 1,
      sym_comment,
    ACTIONS(59), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(61), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3485] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(56), 1,
      sym_comment,
    ACTIONS(266), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(268), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3544] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(57), 1,
      sym_comment,
    ACTIONS(270), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(272), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3603] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(58), 1,
      sym_comment,
    ACTIONS(119), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(121), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3662] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(59), 1,
      sym_comment,
    ACTIONS(274), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(276), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3721] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(60), 1,
      sym_comment,
    ACTIONS(278), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(280), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3780] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(61), 1,
      sym_comment,
    ACTIONS(282), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(284), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3842] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(290), 1,
      anon_sym_elseif,
    STATE(84), 1,
      sym_elseif_clause,
    STATE(62), 2,
      sym_comment,
      aux_sym_if_expression_repeat1,
    ACTIONS(286), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(288), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3904] = 36,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(293), 1,
      anon_sym_end,
    STATE(63), 1,
      sym_comment,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(485), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4023] = 36,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(295), 1,
      anon_sym_end,
    STATE(64), 1,
      sym_comment,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(477), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4142] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    STATE(65), 1,
      sym_comment,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(435), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(297), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4257] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    STATE(66), 1,
      sym_comment,
    STATE(67), 1,
      aux_sym_chunk_repeat1,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(375), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(299), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4370] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(301), 1,
      ts_builtin_sym_end,
    ACTIONS(303), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_SEMI,
    ACTIONS(314), 1,
      anon_sym_do,
    ACTIONS(317), 1,
      anon_sym_while,
    ACTIONS(320), 1,
      anon_sym_repeat,
    ACTIONS(323), 1,
      anon_sym_if,
    ACTIONS(326), 1,
      anon_sym_for,
    ACTIONS(329), 1,
      anon_sym_function,
    ACTIONS(332), 1,
      anon_sym_local,
    ACTIONS(335), 1,
      anon_sym_LPAREN,
    ACTIONS(338), 1,
      anon_sym_export,
    ACTIONS(341), 1,
      anon_sym_type,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    ACTIONS(311), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(67), 2,
      sym_comment,
      aux_sym_chunk_repeat1,
    ACTIONS(306), 5,
      anon_sym_return,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4479] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(180), 1,
      anon_sym_and,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(68), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(344), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(346), 19,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4555] = 29,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(348), 1,
      anon_sym_SEMI,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(69), 1,
      sym_comment,
    STATE(213), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(317), 1,
      sym__expression_list,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    ACTIONS(350), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [4659] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(70), 1,
      sym_comment,
    ACTIONS(376), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(378), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4715] = 35,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(380), 1,
      anon_sym_end,
    ACTIONS(382), 1,
      anon_sym_COLON,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(71), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(475), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4831] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(72), 1,
      sym_comment,
    ACTIONS(115), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(117), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4887] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(73), 1,
      sym_comment,
    ACTIONS(384), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(386), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4943] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(74), 1,
      sym_comment,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(344), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(346), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5013] = 14,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(75), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(344), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(346), 20,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5087] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(76), 1,
      sym_comment,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(344), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DOT_DOT,
    ACTIONS(346), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5151] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(77), 1,
      sym_comment,
    ACTIONS(344), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(346), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5211] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(78), 1,
      sym_comment,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(344), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(346), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5281] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(194), 1,
      anon_sym_CARET,
    STATE(79), 1,
      sym_comment,
    ACTIONS(344), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(346), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5339] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(80), 1,
      sym_comment,
    ACTIONS(51), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(53), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5395] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(81), 1,
      sym_comment,
    ACTIONS(388), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(390), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5451] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(82), 1,
      sym_comment,
    ACTIONS(392), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(394), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5507] = 35,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(396), 1,
      anon_sym_end,
    ACTIONS(398), 1,
      anon_sym_COLON,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(83), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(486), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [5623] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(84), 1,
      sym_comment,
    ACTIONS(400), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(402), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5679] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(85), 1,
      sym_comment,
    ACTIONS(218), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(220), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5735] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(86), 1,
      sym_comment,
    ACTIONS(404), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(406), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5791] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(87), 1,
      sym_comment,
    ACTIONS(83), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(85), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5847] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(88), 1,
      sym_comment,
    ACTIONS(408), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(410), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5903] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(194), 1,
      anon_sym_CARET,
    STATE(89), 1,
      sym_comment,
    ACTIONS(412), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(414), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5961] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(178), 1,
      anon_sym_or,
    ACTIONS(180), 1,
      anon_sym_and,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(90), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(416), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(418), 18,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6039] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(91), 1,
      sym_comment,
    ACTIONS(420), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(422), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6095] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(92), 1,
      sym_comment,
    ACTIONS(424), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(426), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6151] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(93), 1,
      sym_comment,
    ACTIONS(428), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(430), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6207] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(94), 1,
      sym_comment,
    ACTIONS(432), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(434), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6263] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(178), 1,
      anon_sym_or,
    ACTIONS(180), 1,
      anon_sym_and,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(95), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(436), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(438), 18,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6341] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(96), 1,
      sym_comment,
    ACTIONS(440), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(442), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6397] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(444), 1,
      anon_sym_until,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(97), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(483), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [6510] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(446), 1,
      anon_sym_end,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(98), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(532), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [6623] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(448), 1,
      anon_sym_end,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(99), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(528), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [6736] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(450), 1,
      anon_sym_end,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(100), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(489), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [6849] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(144), 1,
      anon_sym_return,
    ACTIONS(452), 1,
      anon_sym_end,
    STATE(66), 1,
      aux_sym_chunk_repeat1,
    STATE(101), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(362), 1,
      sym_return_statement,
    STATE(537), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [6962] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(454), 1,
      ts_builtin_sym_end,
    STATE(67), 1,
      aux_sym_chunk_repeat1,
    STATE(102), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(473), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7072] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(456), 1,
      sym_identifier,
    ACTIONS(458), 1,
      anon_sym_LBRACK,
    ACTIONS(460), 1,
      anon_sym_RBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(103), 1,
      sym_comment,
    STATE(241), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(330), 1,
      sym_field,
    STATE(513), 1,
      sym__field_list,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7176] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(462), 1,
      ts_builtin_sym_end,
    STATE(67), 1,
      aux_sym_chunk_repeat1,
    STATE(104), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(479), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7286] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(462), 1,
      ts_builtin_sym_end,
    STATE(102), 1,
      aux_sym_chunk_repeat1,
    STATE(105), 1,
      sym_comment,
    STATE(211), 1,
      sym_function_call,
    STATE(250), 1,
      sym__local_function_declaration,
    STATE(252), 1,
      sym_statement,
    STATE(253), 1,
      sym_declaration,
    STATE(254), 1,
      sym_function_declaration,
    STATE(271), 1,
      sym_variable_declaration,
    STATE(272), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(305), 1,
      sym_parenthesized_expression,
    STATE(307), 1,
      sym__variable_assignment_varlist,
    STATE(479), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(251), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7396] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(456), 1,
      sym_identifier,
    ACTIONS(458), 1,
      anon_sym_LBRACK,
    ACTIONS(464), 1,
      anon_sym_RBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(106), 1,
      sym_comment,
    STATE(241), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(330), 1,
      sym_field,
    STATE(490), 1,
      sym__field_list,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7500] = 29,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(348), 1,
      anon_sym_SEMI,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(466), 1,
      ts_builtin_sym_end,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(107), 1,
      sym_comment,
    STATE(213), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(317), 1,
      sym__expression_list,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7601] = 29,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(456), 1,
      sym_identifier,
    ACTIONS(458), 1,
      anon_sym_LBRACK,
    ACTIONS(468), 1,
      anon_sym_RBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(108), 1,
      sym_comment,
    STATE(241), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(428), 1,
      sym_field,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7702] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(178), 1,
      anon_sym_or,
    ACTIONS(180), 1,
      anon_sym_and,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(474), 1,
      anon_sym_COMMA,
    STATE(109), 1,
      sym_comment,
    STATE(228), 1,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(472), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7781] = 29,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(456), 1,
      sym_identifier,
    ACTIONS(458), 1,
      anon_sym_LBRACK,
    ACTIONS(476), 1,
      anon_sym_RBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(110), 1,
      sym_comment,
    STATE(241), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(428), 1,
      sym_field,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7882] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(178), 1,
      anon_sym_or,
    ACTIONS(180), 1,
      anon_sym_and,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(111), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(478), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(480), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7956] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(456), 1,
      sym_identifier,
    ACTIONS(458), 1,
      anon_sym_LBRACK,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(112), 1,
      sym_comment,
    STATE(241), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(428), 1,
      sym_field,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8054] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(113), 1,
      sym_comment,
    STATE(260), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8149] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(178), 1,
      anon_sym_or,
    ACTIONS(180), 1,
      anon_sym_and,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(114), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(482), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(484), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [8222] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(115), 1,
      sym_comment,
    STATE(329), 1,
      sym_type,
    STATE(481), 1,
      sym_object_field_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [8303] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(116), 1,
      sym_comment,
    STATE(261), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8398] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(117), 1,
      sym_comment,
    STATE(264), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8493] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(118), 1,
      sym_comment,
    STATE(265), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8588] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(119), 1,
      sym_comment,
    STATE(266), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8683] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(120), 1,
      sym_comment,
    STATE(267), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8778] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(121), 1,
      sym_comment,
    STATE(268), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8873] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(122), 1,
      sym_comment,
    STATE(234), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8968] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(178), 1,
      anon_sym_or,
    ACTIONS(180), 1,
      anon_sym_and,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    STATE(123), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(498), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(500), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [9041] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(502), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(124), 1,
      sym_comment,
    STATE(239), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [9136] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(125), 1,
      sym_comment,
    STATE(213), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(535), 1,
      sym__expression_list,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [9231] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(109), 1,
      sym_expression,
    STATE(126), 1,
      sym_comment,
    STATE(269), 1,
      sym__variable_assignment_explist,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [9326] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      sym_identifier,
    ACTIONS(506), 1,
      anon_sym_COMMA,
    ACTIONS(508), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(127), 1,
      sym_comment,
    STATE(328), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [9407] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(128), 1,
      sym_comment,
    STATE(347), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [9488] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(516), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(129), 1,
      sym_comment,
    STATE(348), 1,
      sym_type,
    STATE(536), 1,
      sym_object_field_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [9569] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(95), 1,
      sym_expression,
    STATE(130), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [9661] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(520), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(131), 1,
      sym_comment,
    STATE(333), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [9739] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(524), 1,
      anon_sym_RBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(132), 1,
      sym_comment,
    STATE(352), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [9817] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(133), 1,
      sym_comment,
    STATE(215), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [9909] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(134), 1,
      sym_comment,
    STATE(278), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10001] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(135), 1,
      sym_comment,
    STATE(276), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10093] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(74), 1,
      sym_expression,
    STATE(136), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10185] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(90), 1,
      sym_expression,
    STATE(137), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10277] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(138), 1,
      sym_comment,
    STATE(273), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10369] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(139), 1,
      sym_comment,
    STATE(275), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10461] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(68), 1,
      sym_expression,
    STATE(140), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10553] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(526), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(141), 1,
      sym_comment,
    STATE(338), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [10631] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(75), 1,
      sym_expression,
    STATE(142), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10723] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(143), 1,
      sym_comment,
    STATE(259), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10815] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(528), 1,
      anon_sym_RBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(144), 1,
      sym_comment,
    STATE(352), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [10893] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(76), 1,
      sym_expression,
    STATE(145), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10985] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(77), 1,
      sym_expression,
    STATE(146), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11077] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym_expression,
    STATE(147), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11169] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(78), 1,
      sym_expression,
    STATE(148), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11261] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(79), 1,
      sym_expression,
    STATE(149), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11353] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(150), 1,
      sym_comment,
    STATE(288), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11445] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(151), 1,
      sym_comment,
    STATE(285), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11537] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(114), 1,
      sym_expression,
    STATE(152), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11629] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(33), 1,
      sym_expression,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(153), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11721] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(154), 1,
      sym_comment,
    STATE(281), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11813] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(155), 1,
      sym_comment,
    STATE(277), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11905] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(156), 1,
      sym_comment,
    STATE(279), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11997] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(530), 1,
      anon_sym_typeof,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(157), 1,
      sym_comment,
    STATE(225), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [12075] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(158), 1,
      sym_comment,
    STATE(233), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12167] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(159), 1,
      sym_comment,
    STATE(286), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12259] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(160), 1,
      sym_comment,
    STATE(331), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [12337] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(161), 1,
      sym_comment,
    STATE(287), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12429] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(536), 1,
      anon_sym_GT,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(162), 1,
      sym_comment,
    STATE(334), 1,
      sym_type,
    STATE(370), 1,
      sym_string,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [12507] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(123), 1,
      sym_expression,
    STATE(163), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12599] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(164), 1,
      sym_comment,
    STATE(280), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12691] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(89), 1,
      sym_expression,
    STATE(165), 1,
      sym_comment,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12783] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    ACTIONS(554), 1,
      anon_sym_GT,
    STATE(166), 1,
      sym_comment,
    STATE(349), 1,
      sym_type,
    STATE(370), 1,
      sym_string,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [12861] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_RBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(167), 1,
      sym_comment,
    STATE(352), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [12939] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(558), 1,
      anon_sym_typeof,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(168), 1,
      sym_comment,
    STATE(230), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13017] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(560), 1,
      anon_sym_RBRACE,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(169), 1,
      sym_comment,
    STATE(352), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13095] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(170), 1,
      sym_comment,
    STATE(283), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [13187] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(562), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(171), 1,
      sym_comment,
    STATE(353), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13265] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(172), 1,
      sym_comment,
    STATE(355), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13343] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(566), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(173), 1,
      sym_comment,
    STATE(356), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13421] = 26,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(352), 1,
      anon_sym_if,
    ACTIONS(354), 1,
      anon_sym_function,
    ACTIONS(356), 1,
      anon_sym_nil,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(370), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(174), 1,
      sym_comment,
    STATE(284), 1,
      sym_expression,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    ACTIONS(358), 2,
      sym_false,
      sym_true,
    ACTIONS(360), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(368), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(5), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(80), 8,
      sym_nil,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [13513] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(50), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(175), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13588] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(176), 1,
      sym_comment,
    STATE(352), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13663] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(177), 1,
      sym_comment,
    STATE(357), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13738] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(178), 1,
      sym_comment,
    STATE(212), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13813] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(179), 1,
      sym_comment,
    STATE(372), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13888] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(64), 1,
      sym_type,
    STATE(180), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [13963] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(181), 1,
      sym_comment,
    STATE(216), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14038] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(40), 1,
      sym_type,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(182), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14113] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(183), 1,
      sym_comment,
    STATE(449), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14188] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(31), 1,
      sym_type,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(184), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14263] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(43), 1,
      sym_type,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(185), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14338] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(186), 1,
      sym_comment,
    STATE(351), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14413] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(63), 1,
      sym_type,
    STATE(187), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14488] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(34), 1,
      sym_type,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(188), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14563] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(45), 1,
      sym_type,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(189), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14638] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(47), 1,
      sym_type,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(190), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14713] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(191), 1,
      sym_comment,
    STATE(366), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14788] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(192), 1,
      sym_comment,
    STATE(367), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14863] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(48), 1,
      sym_type,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(193), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [14938] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(194), 1,
      sym_comment,
    STATE(457), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15013] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(51), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(195), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15088] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(196), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(379), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15163] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(61), 1,
      sym_type,
    STATE(197), 1,
      sym_comment,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15238] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(198), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(381), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15313] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(199), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(382), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15388] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(200), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(385), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15463] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(201), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(389), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15538] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(202), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(391), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15613] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(203), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(393), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15688] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(204), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(395), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15763] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(205), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(396), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15838] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(534), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_DQUOTE,
    ACTIONS(544), 1,
      anon_sym_SQUOTE,
    ACTIONS(546), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(550), 1,
      anon_sym_BQUOTE,
    ACTIONS(552), 1,
      sym__block_string_start,
    STATE(206), 1,
      sym_comment,
    STATE(370), 1,
      sym_string,
    STATE(397), 1,
      sym_type,
    STATE(398), 1,
      sym__quote_string,
    STATE(399), 1,
      sym__block_string,
    STATE(400), 1,
      sym__interpolated_string,
    ACTIONS(540), 2,
      sym_false,
      sym_true,
    STATE(371), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(538), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15913] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(207), 1,
      sym_comment,
    STATE(326), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [15988] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(208), 1,
      sym_comment,
    STATE(354), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [16063] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(364), 1,
      anon_sym_SQUOTE,
    ACTIONS(372), 1,
      anon_sym_BQUOTE,
    ACTIONS(374), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    STATE(30), 1,
      sym__quote_string,
    STATE(38), 1,
      sym__block_string,
    STATE(49), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(209), 1,
      sym_comment,
    STATE(432), 1,
      sym_type,
    ACTIONS(490), 2,
      sym_false,
      sym_true,
    STATE(58), 10,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_optional_type,
      sym_literal_type,
    ACTIONS(488), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
  [16138] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(568), 1,
      anon_sym_EQ,
    STATE(210), 1,
      sym_comment,
    ACTIONS(41), 6,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(39), 23,
      sym__block_string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
  [16184] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(211), 1,
      sym_comment,
    ACTIONS(570), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(57), 9,
      sym__block_string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(572), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16228] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    ACTIONS(580), 1,
      anon_sym_LT,
    STATE(212), 1,
      sym_comment,
    STATE(223), 1,
      sym__attrib,
    STATE(224), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(574), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(576), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16281] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(586), 1,
      anon_sym_else,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    STATE(213), 1,
      sym_comment,
    STATE(304), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(582), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [16347] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    ACTIONS(580), 1,
      anon_sym_LT,
    ACTIONS(596), 1,
      anon_sym_COLON,
    STATE(214), 1,
      sym_comment,
    STATE(218), 1,
      aux_sym__att_name_list_repeat1,
    STATE(219), 1,
      sym__attrib,
    ACTIONS(592), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(594), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16397] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(600), 1,
      anon_sym_else,
    STATE(215), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(598), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [16459] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(580), 1,
      anon_sym_LT,
    STATE(216), 1,
      sym_comment,
    STATE(229), 1,
      sym__attrib,
    ACTIONS(602), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(604), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16507] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(580), 1,
      anon_sym_LT,
    ACTIONS(610), 1,
      anon_sym_COLON,
    STATE(217), 1,
      sym_comment,
    STATE(231), 1,
      sym__attrib,
    ACTIONS(606), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(608), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16552] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    STATE(218), 1,
      sym_comment,
    STATE(222), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(612), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(614), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16593] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    STATE(219), 1,
      sym_comment,
    STATE(220), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(616), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(618), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16634] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    STATE(220), 1,
      sym_comment,
    STATE(222), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(620), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(622), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16675] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    STATE(221), 1,
      sym_comment,
    STATE(222), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(624), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(626), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16716] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(632), 1,
      anon_sym_COMMA,
    STATE(222), 2,
      sym_comment,
      aux_sym__att_name_list_repeat1,
    ACTIONS(628), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(630), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16755] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    STATE(221), 1,
      aux_sym__att_name_list_repeat1,
    STATE(223), 1,
      sym_comment,
    ACTIONS(635), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(637), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16796] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    STATE(222), 1,
      aux_sym__att_name_list_repeat1,
    STATE(224), 1,
      sym_comment,
    ACTIONS(639), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(641), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16837] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(225), 1,
      sym_comment,
    ACTIONS(643), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(645), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16877] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(226), 1,
      sym_comment,
    ACTIONS(647), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(649), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16913] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(655), 1,
      anon_sym_COMMA,
    STATE(227), 2,
      sym_comment,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(651), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(653), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16951] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(474), 1,
      anon_sym_COMMA,
    STATE(227), 1,
      aux_sym__variable_assignment_explist_repeat1,
    STATE(228), 1,
      sym_comment,
    ACTIONS(658), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(660), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16991] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(229), 1,
      sym_comment,
    ACTIONS(662), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(664), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17027] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(230), 1,
      sym_comment,
    ACTIONS(666), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(668), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17067] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(231), 1,
      sym_comment,
    ACTIONS(670), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(672), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17103] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(678), 1,
      anon_sym_EQ,
    STATE(232), 1,
      sym_comment,
    ACTIONS(674), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(676), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17140] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    STATE(233), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(680), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [17194] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(234), 1,
      sym_comment,
    ACTIONS(682), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(684), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17228] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(235), 1,
      sym_comment,
    ACTIONS(686), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(688), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17262] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(236), 1,
      sym_comment,
    ACTIONS(690), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(692), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17296] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(237), 1,
      sym_comment,
    ACTIONS(694), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(696), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17330] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(238), 1,
      sym_comment,
    ACTIONS(698), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(700), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17364] = 17,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(702), 1,
      anon_sym_RPAREN,
    STATE(239), 1,
      sym_comment,
    STATE(438), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [17422] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(240), 1,
      sym_comment,
    ACTIONS(704), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(706), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17456] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    STATE(241), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(708), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [17510] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(242), 1,
      sym_comment,
    ACTIONS(710), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(712), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17544] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(243), 1,
      sym_comment,
    ACTIONS(714), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(716), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17578] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(244), 1,
      sym_comment,
    ACTIONS(718), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(720), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17612] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(245), 1,
      sym_comment,
    ACTIONS(722), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(724), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17646] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(246), 1,
      sym_comment,
    ACTIONS(726), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(728), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17680] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(247), 1,
      sym_comment,
    ACTIONS(730), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(732), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17714] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(248), 1,
      sym_comment,
    ACTIONS(734), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(736), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17748] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(249), 1,
      sym_comment,
    ACTIONS(738), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(740), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17782] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(250), 1,
      sym_comment,
    ACTIONS(742), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(744), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17816] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(251), 1,
      sym_comment,
    ACTIONS(570), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(572), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17850] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(252), 1,
      sym_comment,
    ACTIONS(746), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(748), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17884] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(253), 1,
      sym_comment,
    ACTIONS(750), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(752), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17918] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(254), 1,
      sym_comment,
    ACTIONS(754), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(756), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17952] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(255), 1,
      sym_comment,
    ACTIONS(758), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(760), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17986] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(256), 1,
      sym_comment,
    ACTIONS(762), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(764), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18020] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(257), 1,
      sym_comment,
    ACTIONS(766), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(768), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18054] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(258), 1,
      sym_comment,
    ACTIONS(770), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(772), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18088] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    STATE(259), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(774), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18142] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(260), 1,
      sym_comment,
    ACTIONS(776), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(778), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18176] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(261), 1,
      sym_comment,
    ACTIONS(682), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(684), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18210] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(262), 1,
      sym_comment,
    ACTIONS(780), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(782), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18244] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(263), 1,
      sym_comment,
    ACTIONS(784), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(786), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18278] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(264), 1,
      sym_comment,
    ACTIONS(682), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(684), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18312] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(265), 1,
      sym_comment,
    ACTIONS(682), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(684), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18346] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(266), 1,
      sym_comment,
    ACTIONS(682), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(684), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18380] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(267), 1,
      sym_comment,
    ACTIONS(682), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(684), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18414] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(268), 1,
      sym_comment,
    ACTIONS(682), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(684), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18448] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(269), 1,
      sym_comment,
    ACTIONS(788), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(790), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18482] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(270), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18516] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(271), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18550] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(55), 1,
      anon_sym_DOT,
    ACTIONS(802), 1,
      anon_sym_COMMA,
    STATE(272), 1,
      sym_comment,
    STATE(301), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(57), 8,
      sym__block_string_start,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(800), 8,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [18589] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(804), 1,
      anon_sym_COMMA,
    ACTIONS(806), 1,
      anon_sym_do,
    STATE(273), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18644] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(274), 1,
      sym_comment,
    ACTIONS(808), 8,
      anon_sym_if,
      anon_sym_function,
      anon_sym_nil,
      sym_false,
      sym_true,
      anon_sym_DASH,
      anon_sym_not,
      sym_identifier,
    ACTIONS(810), 11,
      sym__block_string_start,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_vararg_expression,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_BQUOTE,
  [18677] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(812), 1,
      anon_sym_do,
    STATE(275), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18729] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(814), 1,
      anon_sym_then,
    STATE(276), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18781] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(816), 1,
      anon_sym_COMMA,
    STATE(277), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18833] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(818), 1,
      anon_sym_do,
    STATE(278), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18885] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(820), 1,
      anon_sym_RBRACK,
    STATE(279), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18937] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(822), 1,
      anon_sym_then,
    STATE(280), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18989] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(824), 1,
      anon_sym_then,
    STATE(281), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19041] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(55), 1,
      anon_sym_DOT,
    STATE(282), 1,
      sym_comment,
    ACTIONS(57), 8,
      sym__block_string_start,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(826), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [19075] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(828), 1,
      anon_sym_RPAREN,
    STATE(283), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19127] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(830), 1,
      anon_sym_RBRACK,
    STATE(284), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19179] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(832), 1,
      anon_sym_then,
    STATE(285), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19231] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(834), 1,
      anon_sym_RPAREN,
    STATE(286), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19283] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(836), 1,
      anon_sym_RPAREN,
    STATE(287), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19335] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(184), 1,
      anon_sym_PLUS,
    ACTIONS(186), 1,
      anon_sym_DASH,
    ACTIONS(190), 1,
      anon_sym_SLASH,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT,
    ACTIONS(194), 1,
      anon_sym_CARET,
    ACTIONS(196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(588), 1,
      anon_sym_or,
    ACTIONS(590), 1,
      anon_sym_and,
    ACTIONS(838), 1,
      anon_sym_RBRACE,
    STATE(288), 1,
      sym_comment,
    ACTIONS(176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(188), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(182), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19387] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(289), 1,
      sym_comment,
    ACTIONS(842), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
    ACTIONS(840), 14,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19418] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(290), 1,
      sym_comment,
    ACTIONS(846), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
    ACTIONS(844), 14,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19449] = 17,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(848), 1,
      anon_sym_DOT,
    ACTIONS(850), 1,
      anon_sym_COLON,
    ACTIONS(852), 1,
      anon_sym_DQUOTE,
    ACTIONS(854), 1,
      anon_sym_SQUOTE,
    ACTIONS(856), 1,
      anon_sym_LPAREN,
    ACTIONS(858), 1,
      anon_sym_LBRACK,
    ACTIONS(860), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_BQUOTE,
    ACTIONS(864), 1,
      sym__block_string_start,
    STATE(7), 1,
      sym_arguments,
    STATE(14), 1,
      sym__quote_string,
    STATE(15), 1,
      sym__block_string,
    STATE(16), 1,
      sym__interpolated_string,
    STATE(291), 1,
      sym_comment,
    STATE(8), 2,
      sym_string,
      sym_table_constructor,
  [19502] = 14,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(852), 1,
      anon_sym_DQUOTE,
    ACTIONS(854), 1,
      anon_sym_SQUOTE,
    ACTIONS(856), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_BQUOTE,
    ACTIONS(864), 1,
      sym__block_string_start,
    STATE(7), 1,
      sym_arguments,
    STATE(14), 1,
      sym__quote_string,
    STATE(15), 1,
      sym__block_string,
    STATE(16), 1,
      sym__interpolated_string,
    STATE(292), 1,
      sym_comment,
    STATE(8), 2,
      sym_string,
      sym_table_constructor,
  [19546] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(866), 1,
      sym_escape_sequence,
    ACTIONS(868), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(872), 1,
      anon_sym_BQUOTE,
    ACTIONS(874), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(876), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(878), 1,
      aux_sym__escape_sequence_token1,
    STATE(293), 1,
      sym_comment,
    STATE(300), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(319), 1,
      sym__interpolation_string_content,
    STATE(322), 2,
      sym__escape_sequence,
      sym_interpolation,
  [19584] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(600), 1,
      anon_sym_else,
    ACTIONS(880), 1,
      anon_sym_COMMA,
    STATE(294), 2,
      sym_comment,
      aux_sym__expression_list_repeat1,
    ACTIONS(598), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [19610] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(866), 1,
      sym_escape_sequence,
    ACTIONS(868), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(874), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(876), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(878), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(883), 1,
      anon_sym_BQUOTE,
    STATE(295), 1,
      sym_comment,
    STATE(298), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(319), 1,
      sym__interpolation_string_content,
    STATE(322), 2,
      sym__escape_sequence,
      sym_interpolation,
  [19648] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(887), 1,
      anon_sym_COMMA,
    STATE(296), 2,
      sym_comment,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(885), 8,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [19672] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(866), 1,
      sym_escape_sequence,
    ACTIONS(868), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(874), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(876), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(878), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(890), 1,
      anon_sym_BQUOTE,
    STATE(295), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(297), 1,
      sym_comment,
    STATE(319), 1,
      sym__interpolation_string_content,
    STATE(322), 2,
      sym__escape_sequence,
      sym_interpolation,
  [19710] = 11,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(892), 1,
      sym_escape_sequence,
    ACTIONS(895), 1,
      anon_sym_LBRACE,
    ACTIONS(898), 1,
      anon_sym_BQUOTE,
    ACTIONS(900), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(903), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(906), 1,
      aux_sym__escape_sequence_token1,
    STATE(319), 1,
      sym__interpolation_string_content,
    STATE(298), 2,
      sym_comment,
      aux_sym__interpolated_string_repeat1,
    STATE(322), 2,
      sym__escape_sequence,
      sym_interpolation,
  [19746] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(866), 1,
      sym_escape_sequence,
    ACTIONS(868), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(874), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(876), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(878), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(909), 1,
      anon_sym_BQUOTE,
    STATE(299), 1,
      sym_comment,
    STATE(302), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(319), 1,
      sym__interpolation_string_content,
    STATE(322), 2,
      sym__escape_sequence,
      sym_interpolation,
  [19784] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(866), 1,
      sym_escape_sequence,
    ACTIONS(868), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(874), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(876), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(878), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(911), 1,
      anon_sym_BQUOTE,
    STATE(298), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(300), 1,
      sym_comment,
    STATE(319), 1,
      sym__interpolation_string_content,
    STATE(322), 2,
      sym__escape_sequence,
      sym_interpolation,
  [19822] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(802), 1,
      anon_sym_COMMA,
    STATE(296), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    STATE(301), 1,
      sym_comment,
    ACTIONS(913), 8,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [19848] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(866), 1,
      sym_escape_sequence,
    ACTIONS(868), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(874), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(876), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(878), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(915), 1,
      anon_sym_BQUOTE,
    STATE(298), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(302), 1,
      sym_comment,
    STATE(319), 1,
      sym__interpolation_string_content,
    STATE(322), 2,
      sym__escape_sequence,
      sym_interpolation,
  [19886] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(917), 1,
      sym_identifier,
    STATE(282), 1,
      sym_variable,
    STATE(291), 1,
      sym__prefix_expression,
    STATE(292), 1,
      sym_method_index_expression,
    STATE(303), 1,
      sym_comment,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(305), 2,
      sym_function_call,
      sym_parenthesized_expression,
  [19919] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(921), 1,
      anon_sym_else,
    STATE(294), 1,
      aux_sym__expression_list_repeat1,
    STATE(304), 1,
      sym_comment,
    ACTIONS(919), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [19946] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(305), 1,
      sym_comment,
    ACTIONS(57), 9,
      sym__block_string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
  [19967] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DOT,
    ACTIONS(925), 1,
      anon_sym_COLON,
    ACTIONS(927), 1,
      anon_sym_LT,
    STATE(23), 1,
      aux_sym_field_type_repeat1,
    STATE(306), 1,
      sym_comment,
    ACTIONS(119), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [19995] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(929), 1,
      anon_sym_EQ,
    ACTIONS(931), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(933), 1,
      anon_sym_DASH_EQ,
    ACTIONS(935), 1,
      anon_sym_STAR_EQ,
    ACTIONS(937), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(939), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(941), 1,
      anon_sym_CARET_EQ,
    ACTIONS(943), 1,
      anon_sym_DOT_DOT_EQ,
    STATE(307), 1,
      sym_comment,
  [20029] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DOT,
    ACTIONS(927), 1,
      anon_sym_LT,
    ACTIONS(945), 1,
      anon_sym_COLON,
    STATE(23), 1,
      aux_sym_field_type_repeat1,
    STATE(308), 1,
      sym_comment,
    ACTIONS(119), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20057] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DOT,
    ACTIONS(927), 1,
      anon_sym_LT,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(23), 1,
      aux_sym_field_type_repeat1,
    STATE(309), 1,
      sym_comment,
    ACTIONS(119), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20085] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DOT,
    ACTIONS(927), 1,
      anon_sym_LT,
    ACTIONS(949), 1,
      anon_sym_COLON,
    STATE(23), 1,
      aux_sym_field_type_repeat1,
    STATE(310), 1,
      sym_comment,
    ACTIONS(119), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20113] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DOT,
    ACTIONS(927), 1,
      anon_sym_LT,
    ACTIONS(951), 1,
      anon_sym_COLON,
    STATE(23), 1,
      aux_sym_field_type_repeat1,
    STATE(311), 1,
      sym_comment,
    ACTIONS(119), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20141] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(953), 1,
      anon_sym_DOT,
    ACTIONS(955), 1,
      anon_sym_LT,
    STATE(312), 1,
      sym_comment,
    STATE(318), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(119), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20166] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(959), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(313), 1,
      sym_comment,
    ACTIONS(957), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [20186] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(314), 1,
      sym_comment,
    ACTIONS(961), 6,
      sym__block_string_start,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
  [20204] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(150), 1,
      anon_sym_else,
    ACTIONS(963), 1,
      anon_sym_end,
    ACTIONS(965), 1,
      anon_sym_elseif,
    STATE(315), 1,
      sym_comment,
    STATE(345), 1,
      aux_sym_if_statement_repeat1,
    STATE(439), 1,
      sym_elseif_statement,
    STATE(526), 1,
      sym_else_statement,
  [20232] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(150), 1,
      anon_sym_else,
    ACTIONS(965), 1,
      anon_sym_elseif,
    ACTIONS(967), 1,
      anon_sym_end,
    STATE(315), 1,
      aux_sym_if_statement_repeat1,
    STATE(316), 1,
      sym_comment,
    STATE(439), 1,
      sym_elseif_statement,
    STATE(497), 1,
      sym_else_statement,
  [20260] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(971), 1,
      anon_sym_SEMI,
    ACTIONS(973), 1,
      anon_sym_else,
    STATE(317), 1,
      sym_comment,
    ACTIONS(969), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [20282] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(953), 1,
      anon_sym_DOT,
    STATE(318), 1,
      sym_comment,
    STATE(321), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(127), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20304] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(977), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(319), 1,
      sym_comment,
    ACTIONS(975), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [20324] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(150), 1,
      anon_sym_else,
    ACTIONS(965), 1,
      anon_sym_elseif,
    ACTIONS(979), 1,
      anon_sym_end,
    STATE(320), 1,
      sym_comment,
    STATE(345), 1,
      aux_sym_if_statement_repeat1,
    STATE(439), 1,
      sym_elseif_statement,
    STATE(533), 1,
      sym_else_statement,
  [20352] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(981), 1,
      anon_sym_DOT,
    STATE(321), 2,
      sym_comment,
      aux_sym_field_type_repeat1,
    ACTIONS(131), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20372] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(986), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(322), 1,
      sym_comment,
    ACTIONS(984), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [20392] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(990), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(323), 1,
      sym_comment,
    ACTIONS(988), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [20412] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(959), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(324), 1,
      sym_comment,
    ACTIONS(957), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [20432] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(994), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(325), 1,
      sym_comment,
    ACTIONS(992), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [20452] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(560), 1,
      anon_sym_RBRACE,
    ACTIONS(996), 1,
      anon_sym_COMMA,
    STATE(326), 1,
      sym_comment,
    STATE(419), 1,
      aux_sym_object_type_repeat1,
  [20477] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_LT,
    ACTIONS(1000), 1,
      anon_sym_LPAREN,
    STATE(83), 1,
      sym_parameters,
    STATE(263), 1,
      sym__function_body,
    STATE(327), 1,
      sym_comment,
    STATE(461), 1,
      sym_generic_type_list,
  [20502] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1004), 1,
      anon_sym_RPAREN,
    STATE(328), 1,
      sym_comment,
    STATE(446), 1,
      aux_sym_tuple_type_repeat1,
  [20527] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1006), 1,
      anon_sym_COMMA,
    ACTIONS(1008), 1,
      anon_sym_RBRACE,
    STATE(329), 1,
      sym_comment,
    STATE(425), 1,
      aux_sym_tuple_type_repeat1,
  [20552] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_RBRACE,
    STATE(110), 1,
      sym__field_sep,
    STATE(330), 1,
      sym_comment,
    STATE(346), 1,
      aux_sym__field_list_repeat1,
    ACTIONS(1010), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [20575] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1014), 1,
      anon_sym_RPAREN,
    STATE(331), 1,
      sym_comment,
    STATE(447), 1,
      aux_sym_tuple_type_repeat1,
  [20600] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(973), 1,
      anon_sym_else,
    STATE(332), 1,
      sym_comment,
    ACTIONS(969), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [20619] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(526), 1,
      anon_sym_RPAREN,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    STATE(333), 1,
      sym_comment,
    STATE(437), 1,
      aux_sym_tuple_type_repeat1,
  [20644] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1016), 1,
      anon_sym_COMMA,
    ACTIONS(1018), 1,
      anon_sym_GT,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(334), 1,
      sym_comment,
    STATE(451), 1,
      aux_sym_tuple_type_repeat1,
  [20669] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1026), 1,
      anon_sym_else,
    STATE(335), 1,
      sym_comment,
    ACTIONS(1024), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [20688] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_LT,
    ACTIONS(1000), 1,
      anon_sym_LPAREN,
    STATE(82), 1,
      sym__function_body,
    STATE(83), 1,
      sym_parameters,
    STATE(336), 1,
      sym_comment,
    STATE(461), 1,
      sym_generic_type_list,
  [20713] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1028), 1,
      sym_identifier,
    STATE(337), 1,
      sym_comment,
    STATE(341), 1,
      sym__function_name,
    STATE(394), 1,
      sym__function_name_dot_index_expression,
    STATE(418), 1,
      sym__function_name_prefix_expression,
    STATE(459), 1,
      sym__function_name_method_index_expression,
  [20738] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1030), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      sym_comment,
    STATE(448), 1,
      aux_sym_tuple_type_repeat1,
  [20763] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1032), 1,
      anon_sym_DASH_GT,
    STATE(339), 1,
      sym_comment,
    ACTIONS(138), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20782] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1037), 1,
      anon_sym_RBRACE,
    STATE(112), 1,
      sym__field_sep,
    ACTIONS(1034), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(340), 2,
      sym_comment,
      aux_sym__field_list_repeat1,
  [20803] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_LT,
    ACTIONS(1000), 1,
      anon_sym_LPAREN,
    STATE(83), 1,
      sym_parameters,
    STATE(257), 1,
      sym__function_body,
    STATE(341), 1,
      sym_comment,
    STATE(461), 1,
      sym_generic_type_list,
  [20828] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1039), 1,
      anon_sym_DASH_GT,
    STATE(342), 1,
      sym_comment,
    ACTIONS(152), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20847] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(343), 1,
      sym_comment,
    ACTIONS(131), 5,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20864] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1041), 1,
      anon_sym_DASH_GT,
    STATE(344), 1,
      sym_comment,
    ACTIONS(158), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [20883] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1043), 1,
      anon_sym_end,
    ACTIONS(1045), 1,
      anon_sym_elseif,
    ACTIONS(1048), 1,
      anon_sym_else,
    STATE(439), 1,
      sym_elseif_statement,
    STATE(345), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [20906] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(476), 1,
      anon_sym_RBRACE,
    STATE(108), 1,
      sym__field_sep,
    STATE(340), 1,
      aux_sym__field_list_repeat1,
    STATE(346), 1,
      sym_comment,
    ACTIONS(1010), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [20929] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    STATE(347), 1,
      sym_comment,
    STATE(440), 1,
      aux_sym_tuple_type_repeat1,
  [20954] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1052), 1,
      anon_sym_COMMA,
    ACTIONS(1054), 1,
      anon_sym_RBRACE,
    STATE(348), 1,
      sym_comment,
    STATE(441), 1,
      aux_sym_tuple_type_repeat1,
  [20979] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1016), 1,
      anon_sym_COMMA,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    ACTIONS(1056), 1,
      anon_sym_GT,
    STATE(349), 1,
      sym_comment,
    STATE(442), 1,
      aux_sym_tuple_type_repeat1,
  [21004] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1058), 1,
      sym_identifier,
    ACTIONS(1060), 1,
      sym_vararg_expression,
    ACTIONS(1062), 1,
      anon_sym_RPAREN,
    STATE(350), 1,
      sym_comment,
    STATE(427), 1,
      sym_parameter,
    STATE(471), 1,
      sym__parameter_list,
  [21029] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1064), 1,
      anon_sym_COMMA,
    ACTIONS(1066), 1,
      anon_sym_RPAREN,
    STATE(351), 1,
      sym_comment,
    STATE(430), 1,
      aux_sym_function_type_repeat1,
  [21054] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(352), 1,
      sym_comment,
    ACTIONS(1068), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [21075] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1070), 1,
      anon_sym_RPAREN,
    STATE(353), 1,
      sym_comment,
    STATE(452), 1,
      aux_sym_tuple_type_repeat1,
  [21100] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1072), 1,
      anon_sym_COMMA,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    STATE(354), 1,
      sym_comment,
    STATE(454), 1,
      aux_sym_function_type_repeat1,
  [21125] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(566), 1,
      anon_sym_RPAREN,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_comment,
    STATE(455), 1,
      aux_sym_tuple_type_repeat1,
  [21150] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1076), 1,
      anon_sym_RPAREN,
    STATE(356), 1,
      sym_comment,
    STATE(456), 1,
      aux_sym_tuple_type_repeat1,
  [21175] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(528), 1,
      anon_sym_RBRACE,
    ACTIONS(1078), 1,
      anon_sym_COMMA,
    STATE(357), 1,
      sym_comment,
    STATE(424), 1,
      aux_sym_object_type_repeat1,
  [21200] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1080), 1,
      anon_sym_SQUOTE,
    STATE(358), 1,
      sym_comment,
    STATE(380), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1082), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [21220] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(1084), 1,
      sym_identifier,
    ACTIONS(1086), 1,
      anon_sym_RBRACE,
    STATE(359), 1,
      sym_comment,
    STATE(470), 1,
      sym_object_field_type,
  [21242] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1088), 1,
      anon_sym_DQUOTE,
    STATE(360), 1,
      sym_comment,
    STATE(365), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1090), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [21262] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    STATE(361), 1,
      sym_comment,
    STATE(415), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1082), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [21282] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(299), 1,
      anon_sym_else,
    STATE(362), 1,
      sym_comment,
    ACTIONS(1092), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [21300] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(1084), 1,
      sym_identifier,
    ACTIONS(1094), 1,
      anon_sym_RBRACE,
    STATE(363), 1,
      sym_comment,
    STATE(470), 1,
      sym_object_field_type,
  [21322] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1096), 1,
      sym_identifier,
    STATE(364), 1,
      sym_comment,
    STATE(480), 1,
      sym__name_list,
    STATE(469), 2,
      sym_for_generic_clause,
      sym_for_numeric_clause,
  [21342] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1098), 1,
      anon_sym_DQUOTE,
    STATE(365), 1,
      sym_comment,
    STATE(378), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1090), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [21362] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(366), 1,
      sym_comment,
    ACTIONS(1100), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [21382] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(367), 1,
      sym_comment,
    ACTIONS(1102), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [21402] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1104), 1,
      anon_sym_EQ,
    ACTIONS(1106), 1,
      anon_sym_COMMA,
    ACTIONS(1108), 1,
      anon_sym_in,
    STATE(368), 1,
      sym_comment,
    STATE(436), 1,
      aux_sym__name_list_repeat1,
  [21424] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(369), 1,
      sym_comment,
    ACTIONS(230), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21440] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(370), 1,
      sym_comment,
    ACTIONS(266), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21456] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(371), 1,
      sym_comment,
    ACTIONS(119), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21472] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    STATE(372), 1,
      sym_comment,
    ACTIONS(1110), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [21492] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(373), 1,
      sym_comment,
    ACTIONS(206), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21508] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(374), 1,
      sym_comment,
    ACTIONS(1112), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [21524] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1116), 1,
      anon_sym_else,
    STATE(375), 1,
      sym_comment,
    ACTIONS(1114), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [21542] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(376), 1,
      sym_comment,
    ACTIONS(270), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21558] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(377), 1,
      sym_comment,
    ACTIONS(274), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21574] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1118), 1,
      anon_sym_DQUOTE,
    ACTIONS(1120), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
    STATE(378), 2,
      aux_sym__doublequote_string_content,
      sym_comment,
  [21592] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(379), 1,
      sym_comment,
    ACTIONS(164), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21608] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1123), 1,
      anon_sym_SQUOTE,
    ACTIONS(1125), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
    STATE(380), 2,
      aux_sym__singlequote_string_content,
      sym_comment,
  [21626] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(381), 1,
      sym_comment,
    ACTIONS(198), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21646] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(382), 1,
      sym_comment,
    ACTIONS(1068), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21666] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(383), 1,
      sym_comment,
    ACTIONS(210), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21682] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(384), 1,
      sym_comment,
    ACTIONS(214), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21698] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(385), 1,
      sym_comment,
    ACTIONS(222), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21718] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_function,
    STATE(232), 1,
      sym__att_name_list,
    STATE(258), 1,
      sym__local_variable_assignment,
    STATE(386), 1,
      sym_comment,
  [21740] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(387), 1,
      sym_comment,
    ACTIONS(226), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21756] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(388), 1,
      sym_comment,
    ACTIONS(278), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21772] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(389), 1,
      sym_comment,
    ACTIONS(234), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21792] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(390), 1,
      sym_comment,
    ACTIONS(238), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21808] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(391), 1,
      sym_comment,
    ACTIONS(242), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21828] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(392), 1,
      sym_comment,
    ACTIONS(246), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21844] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(393), 1,
      sym_comment,
    ACTIONS(250), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21864] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(394), 1,
      sym_comment,
    ACTIONS(1132), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [21880] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(395), 1,
      sym_comment,
    ACTIONS(254), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21900] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(396), 1,
      sym_comment,
    ACTIONS(258), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21920] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_QMARK,
    STATE(397), 1,
      sym_comment,
    ACTIONS(262), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21940] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(398), 1,
      sym_comment,
    ACTIONS(91), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21956] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(399), 1,
      sym_comment,
    ACTIONS(91), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21972] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(400), 1,
      sym_comment,
    ACTIONS(95), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [21988] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(401), 1,
      sym_comment,
    ACTIONS(99), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [22004] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(402), 1,
      sym_comment,
    ACTIONS(103), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [22020] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(403), 1,
      sym_comment,
    ACTIONS(107), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [22036] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(404), 1,
      sym_comment,
    ACTIONS(111), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [22052] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(405), 1,
      sym_comment,
    ACTIONS(59), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [22068] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1134), 1,
      anon_sym_DQUOTE,
    STATE(406), 1,
      sym_comment,
    STATE(408), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1090), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [22088] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1134), 1,
      anon_sym_SQUOTE,
    STATE(407), 1,
      sym_comment,
    STATE(409), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1082), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [22108] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1136), 1,
      anon_sym_DQUOTE,
    STATE(378), 1,
      aux_sym__doublequote_string_content,
    STATE(408), 1,
      sym_comment,
    ACTIONS(1090), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [22128] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1136), 1,
      anon_sym_SQUOTE,
    STATE(380), 1,
      aux_sym__singlequote_string_content,
    STATE(409), 1,
      sym_comment,
    ACTIONS(1082), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [22148] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(1084), 1,
      sym_identifier,
    ACTIONS(1138), 1,
      anon_sym_RBRACE,
    STATE(410), 1,
      sym_comment,
    STATE(470), 1,
      sym_object_field_type,
  [22170] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(1084), 1,
      sym_identifier,
    ACTIONS(1140), 1,
      anon_sym_RBRACE,
    STATE(411), 1,
      sym_comment,
    STATE(470), 1,
      sym_object_field_type,
  [22192] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1142), 1,
      anon_sym_DQUOTE,
    STATE(412), 1,
      sym_comment,
    STATE(414), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1090), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [22212] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1142), 1,
      anon_sym_SQUOTE,
    STATE(358), 1,
      aux_sym__singlequote_string_content,
    STATE(413), 1,
      sym_comment,
    ACTIONS(1082), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [22232] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1080), 1,
      anon_sym_DQUOTE,
    STATE(378), 1,
      aux_sym__doublequote_string_content,
    STATE(414), 1,
      sym_comment,
    ACTIONS(1090), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [22252] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1098), 1,
      anon_sym_SQUOTE,
    STATE(380), 1,
      aux_sym__singlequote_string_content,
    STATE(415), 1,
      sym_comment,
    ACTIONS(1082), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [22272] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1144), 1,
      anon_sym_COMMA,
    ACTIONS(1068), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(416), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [22290] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(417), 1,
      sym_comment,
    ACTIONS(1147), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [22306] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1149), 1,
      anon_sym_DOT,
    ACTIONS(1151), 1,
      anon_sym_COLON,
    STATE(418), 1,
      sym_comment,
    ACTIONS(1153), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [22326] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1138), 1,
      anon_sym_RBRACE,
    ACTIONS(1155), 1,
      anon_sym_COMMA,
    STATE(419), 1,
      sym_comment,
    STATE(431), 1,
      aux_sym_object_type_repeat1,
  [22345] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1058), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      sym_vararg_expression,
    STATE(420), 1,
      sym_comment,
    STATE(465), 1,
      sym_parameter,
  [22364] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1159), 1,
      anon_sym_COMMA,
    ACTIONS(1161), 1,
      anon_sym_RPAREN,
    STATE(421), 1,
      sym_comment,
    STATE(444), 1,
      aux_sym__parameter_list_repeat1,
  [22383] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1165), 1,
      anon_sym_COLON,
    STATE(422), 1,
      sym_comment,
    ACTIONS(1163), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [22400] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1167), 1,
      anon_sym_SQUOTE,
    STATE(423), 1,
      sym_comment,
    ACTIONS(1169), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [22417] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1086), 1,
      anon_sym_RBRACE,
    ACTIONS(1171), 1,
      anon_sym_COMMA,
    STATE(424), 1,
      sym_comment,
    STATE(431), 1,
      aux_sym_object_type_repeat1,
  [22436] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(524), 1,
      anon_sym_RBRACE,
    ACTIONS(1173), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(425), 1,
      sym_comment,
  [22455] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1175), 1,
      anon_sym_COMMA,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
    STATE(426), 2,
      sym_comment,
      aux_sym_function_type_repeat1,
  [22472] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1180), 1,
      anon_sym_COMMA,
    ACTIONS(1182), 1,
      anon_sym_RPAREN,
    STATE(421), 1,
      aux_sym__parameter_list_repeat1,
    STATE(427), 1,
      sym_comment,
  [22491] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(428), 1,
      sym_comment,
    ACTIONS(1037), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [22506] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1184), 1,
      anon_sym_COMMA,
    ACTIONS(1187), 1,
      anon_sym_GT,
    STATE(429), 2,
      sym_comment,
      aux_sym_generic_type_list_repeat1,
  [22523] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(520), 1,
      anon_sym_RPAREN,
    ACTIONS(1189), 1,
      anon_sym_COMMA,
    STATE(426), 1,
      aux_sym_function_type_repeat1,
    STATE(430), 1,
      sym_comment,
  [22542] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1191), 1,
      anon_sym_COMMA,
    ACTIONS(1194), 1,
      anon_sym_RBRACE,
    STATE(431), 2,
      sym_comment,
      aux_sym_object_type_repeat1,
  [22559] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1196), 1,
      anon_sym_EQ,
    STATE(432), 1,
      sym_comment,
  [22578] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1198), 1,
      anon_sym_DQUOTE,
    STATE(433), 1,
      sym_comment,
    ACTIONS(1200), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [22595] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1058), 1,
      sym_identifier,
    ACTIONS(1202), 1,
      sym_vararg_expression,
    STATE(434), 1,
      sym_comment,
    STATE(465), 1,
      sym_parameter,
  [22614] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1206), 1,
      anon_sym_else,
    STATE(435), 1,
      sym_comment,
    ACTIONS(1204), 2,
      anon_sym_end,
      anon_sym_elseif,
  [22631] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1106), 1,
      anon_sym_COMMA,
    ACTIONS(1208), 1,
      anon_sym_in,
    STATE(436), 1,
      sym_comment,
    STATE(450), 1,
      aux_sym__name_list_repeat1,
  [22650] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1030), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(437), 1,
      sym_comment,
  [22669] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(1210), 1,
      anon_sym_RPAREN,
    STATE(294), 1,
      aux_sym__expression_list_repeat1,
    STATE(438), 1,
      sym_comment,
  [22688] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1214), 1,
      anon_sym_else,
    STATE(439), 1,
      sym_comment,
    ACTIONS(1212), 2,
      anon_sym_end,
      anon_sym_elseif,
  [22705] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1216), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(440), 1,
      sym_comment,
  [22724] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      anon_sym_RBRACE,
    ACTIONS(1218), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(441), 1,
      sym_comment,
  [22743] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1016), 1,
      anon_sym_COMMA,
    ACTIONS(1220), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym_comment,
    STATE(445), 1,
      aux_sym_tuple_type_repeat1,
  [22762] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(1084), 1,
      sym_identifier,
    STATE(443), 1,
      sym_comment,
    STATE(470), 1,
      sym_object_field_type,
  [22781] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1222), 1,
      anon_sym_COMMA,
    ACTIONS(1225), 1,
      anon_sym_RPAREN,
    STATE(444), 2,
      sym_comment,
      aux_sym__parameter_list_repeat1,
  [22798] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1068), 1,
      anon_sym_GT,
    ACTIONS(1227), 1,
      anon_sym_COMMA,
    STATE(445), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [22815] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1230), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(446), 1,
      sym_comment,
  [22834] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1066), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(447), 1,
      sym_comment,
  [22853] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1232), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(448), 1,
      sym_comment,
  [22872] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1234), 1,
      anon_sym_RBRACK,
    STATE(449), 1,
      sym_comment,
  [22891] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1236), 1,
      anon_sym_COMMA,
    ACTIONS(1239), 1,
      anon_sym_in,
    STATE(450), 2,
      sym_comment,
      aux_sym__name_list_repeat1,
  [22908] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1016), 1,
      anon_sym_COMMA,
    ACTIONS(1241), 1,
      anon_sym_GT,
    STATE(445), 1,
      aux_sym_tuple_type_repeat1,
    STATE(451), 1,
      sym_comment,
  [22927] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(452), 1,
      sym_comment,
  [22946] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1243), 1,
      anon_sym_COMMA,
    ACTIONS(1245), 1,
      anon_sym_GT,
    STATE(429), 1,
      aux_sym_generic_type_list_repeat1,
    STATE(453), 1,
      sym_comment,
  [22965] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(564), 1,
      anon_sym_RPAREN,
    ACTIONS(1247), 1,
      anon_sym_COMMA,
    STATE(426), 1,
      aux_sym_function_type_repeat1,
    STATE(454), 1,
      sym_comment,
  [22984] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1076), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(455), 1,
      sym_comment,
  [23003] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1002), 1,
      anon_sym_COMMA,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      aux_sym_tuple_type_repeat1,
    STATE(456), 1,
      sym_comment,
  [23022] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(202), 1,
      anon_sym_PIPE,
    ACTIONS(204), 1,
      anon_sym_QMARK,
    ACTIONS(1251), 1,
      anon_sym_EQ,
    STATE(457), 1,
      sym_comment,
  [23041] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1243), 1,
      anon_sym_COMMA,
    ACTIONS(1253), 1,
      anon_sym_GT,
    STATE(453), 1,
      aux_sym_generic_type_list_repeat1,
    STATE(458), 1,
      sym_comment,
  [23060] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(459), 1,
      sym_comment,
    ACTIONS(1255), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [23074] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1058), 1,
      sym_identifier,
    STATE(460), 1,
      sym_comment,
    STATE(465), 1,
      sym_parameter,
  [23090] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1000), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym_parameters,
    STATE(461), 1,
      sym_comment,
  [23106] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(462), 1,
      sym_comment,
    ACTIONS(1187), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [23120] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(463), 1,
      sym_comment,
    ACTIONS(1257), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [23134] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(464), 1,
      sym_comment,
    ACTIONS(1259), 2,
      anon_sym_COMMA,
      anon_sym_in,
  [23148] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(465), 1,
      sym_comment,
    ACTIONS(1225), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [23162] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1261), 1,
      sym_identifier,
    STATE(466), 1,
      sym_comment,
  [23175] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1263), 1,
      anon_sym_RPAREN,
    STATE(467), 1,
      sym_comment,
  [23188] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1182), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym_comment,
  [23201] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1265), 1,
      anon_sym_do,
    STATE(469), 1,
      sym_comment,
  [23214] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1267), 1,
      anon_sym_COLON,
    STATE(470), 1,
      sym_comment,
  [23227] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1269), 1,
      anon_sym_RPAREN,
    STATE(471), 1,
      sym_comment,
  [23240] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1271), 1,
      anon_sym_GT,
    STATE(472), 1,
      sym_comment,
  [23253] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1273), 1,
      ts_builtin_sym_end,
    STATE(473), 1,
      sym_comment,
  [23266] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1275), 1,
      sym__block_comment_end,
    STATE(474), 1,
      sym_comment,
  [23279] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1277), 1,
      anon_sym_end,
    STATE(475), 1,
      sym_comment,
  [23292] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1279), 1,
      anon_sym_EQ,
    STATE(476), 1,
      sym_comment,
  [23305] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1281), 1,
      anon_sym_end,
    STATE(477), 1,
      sym_comment,
  [23318] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
    STATE(478), 1,
      sym_comment,
  [23331] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(454), 1,
      ts_builtin_sym_end,
    STATE(479), 1,
      sym_comment,
  [23344] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1285), 1,
      anon_sym_in,
    STATE(480), 1,
      sym_comment,
  [23357] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(949), 1,
      anon_sym_COLON,
    STATE(481), 1,
      sym_comment,
  [23370] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1287), 1,
      ts_builtin_sym_end,
    STATE(482), 1,
      sym_comment,
  [23383] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1289), 1,
      anon_sym_until,
    STATE(483), 1,
      sym_comment,
  [23396] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1291), 1,
      sym_identifier,
    STATE(484), 1,
      sym_comment,
  [23409] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1293), 1,
      anon_sym_end,
    STATE(485), 1,
      sym_comment,
  [23422] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1295), 1,
      anon_sym_end,
    STATE(486), 1,
      sym_comment,
  [23435] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1297), 1,
      sym__block_string_end,
    STATE(487), 1,
      sym_comment,
  [23448] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1299), 1,
      anon_sym_type,
    STATE(488), 1,
      sym_comment,
  [23461] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1301), 1,
      anon_sym_end,
    STATE(489), 1,
      sym_comment,
  [23474] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1303), 1,
      anon_sym_RBRACE,
    STATE(490), 1,
      sym_comment,
  [23487] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1305), 1,
      sym__block_string_end,
    STATE(491), 1,
      sym_comment,
  [23500] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1307), 1,
      sym_identifier,
    STATE(492), 1,
      sym_comment,
  [23513] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1309), 1,
      anon_sym_RPAREN,
    STATE(493), 1,
      sym_comment,
  [23526] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1311), 1,
      sym_identifier,
    STATE(494), 1,
      sym_comment,
  [23539] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1313), 1,
      anon_sym_LPAREN,
    STATE(495), 1,
      sym_comment,
  [23552] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1039), 1,
      anon_sym_DASH_GT,
    STATE(496), 1,
      sym_comment,
  [23565] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1315), 1,
      anon_sym_end,
    STATE(497), 1,
      sym_comment,
  [23578] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1317), 1,
      anon_sym_DASH_GT,
    STATE(498), 1,
      sym_comment,
  [23591] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1319), 1,
      sym__block_comment_content,
    STATE(499), 1,
      sym_comment,
  [23604] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1321), 1,
      anon_sym_end,
    STATE(500), 1,
      sym_comment,
  [23617] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1041), 1,
      anon_sym_DASH_GT,
    STATE(501), 1,
      sym_comment,
  [23630] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(502), 1,
      sym_comment,
  [23643] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(162), 1,
      anon_sym_DASH_GT,
    STATE(503), 1,
      sym_comment,
  [23656] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1325), 1,
      anon_sym_DASH_GT,
    STATE(504), 1,
      sym_comment,
  [23669] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1327), 1,
      anon_sym_DASH_GT,
    STATE(505), 1,
      sym_comment,
  [23682] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1329), 1,
      sym_identifier,
    STATE(506), 1,
      sym_comment,
  [23695] = 4,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(870), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1331), 1,
      aux_sym_comment_token1,
    STATE(507), 1,
      sym_comment,
  [23708] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1333), 1,
      anon_sym_DASH_GT,
    STATE(508), 1,
      sym_comment,
  [23721] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1335), 1,
      sym_identifier,
    STATE(509), 1,
      sym_comment,
  [23734] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1337), 1,
      anon_sym_DASH_GT,
    STATE(510), 1,
      sym_comment,
  [23747] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1339), 1,
      anon_sym_DASH_GT,
    STATE(511), 1,
      sym_comment,
  [23760] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1341), 1,
      anon_sym_DASH_GT,
    STATE(512), 1,
      sym_comment,
  [23773] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1343), 1,
      anon_sym_RBRACE,
    STATE(513), 1,
      sym_comment,
  [23786] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1345), 1,
      sym_identifier,
    STATE(514), 1,
      sym_comment,
  [23799] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1347), 1,
      sym_identifier,
    STATE(515), 1,
      sym_comment,
  [23812] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1349), 1,
      sym__block_string_end,
    STATE(516), 1,
      sym_comment,
  [23825] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1351), 1,
      sym__block_string_content,
    STATE(517), 1,
      sym_comment,
  [23838] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1353), 1,
      anon_sym_LPAREN,
    STATE(518), 1,
      sym_comment,
  [23851] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1355), 1,
      sym_identifier,
    STATE(519), 1,
      sym_comment,
  [23864] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1357), 1,
      sym__block_string_content,
    STATE(520), 1,
      sym_comment,
  [23877] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(462), 1,
      ts_builtin_sym_end,
    STATE(521), 1,
      sym_comment,
  [23890] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1359), 1,
      anon_sym_DASH_GT,
    STATE(522), 1,
      sym_comment,
  [23903] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1361), 1,
      sym_identifier,
    STATE(523), 1,
      sym_comment,
  [23916] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(945), 1,
      anon_sym_COLON,
    STATE(524), 1,
      sym_comment,
  [23929] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1363), 1,
      anon_sym_DASH_GT,
    STATE(525), 1,
      sym_comment,
  [23942] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1365), 1,
      anon_sym_end,
    STATE(526), 1,
      sym_comment,
  [23955] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(156), 1,
      anon_sym_DASH_GT,
    STATE(527), 1,
      sym_comment,
  [23968] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1367), 1,
      anon_sym_end,
    STATE(528), 1,
      sym_comment,
  [23981] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1369), 1,
      sym_identifier,
    STATE(529), 1,
      sym_comment,
  [23994] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1371), 1,
      anon_sym_COLON,
    STATE(530), 1,
      sym_comment,
  [24007] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1373), 1,
      anon_sym_DASH_GT,
    STATE(531), 1,
      sym_comment,
  [24020] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1375), 1,
      anon_sym_end,
    STATE(532), 1,
      sym_comment,
  [24033] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1377), 1,
      anon_sym_end,
    STATE(533), 1,
      sym_comment,
  [24046] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1379), 1,
      sym__block_string_content,
    STATE(534), 1,
      sym_comment,
  [24059] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1381), 1,
      anon_sym_do,
    STATE(535), 1,
      sym_comment,
  [24072] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(536), 1,
      sym_comment,
  [24085] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1383), 1,
      anon_sym_end,
    STATE(537), 1,
      sym_comment,
  [24098] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1385), 1,
      sym_identifier,
    STATE(538), 1,
      sym_comment,
  [24111] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1387), 1,
      anon_sym_LPAREN,
    STATE(539), 1,
      sym_comment,
  [24124] = 1,
    ACTIONS(1389), 1,
      ts_builtin_sym_end,
  [24128] = 1,
    ACTIONS(1391), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 72,
  [SMALL_STATE(4)] = 144,
  [SMALL_STATE(5)] = 216,
  [SMALL_STATE(6)] = 284,
  [SMALL_STATE(7)] = 348,
  [SMALL_STATE(8)] = 412,
  [SMALL_STATE(9)] = 476,
  [SMALL_STATE(10)] = 540,
  [SMALL_STATE(11)] = 604,
  [SMALL_STATE(12)] = 668,
  [SMALL_STATE(13)] = 732,
  [SMALL_STATE(14)] = 796,
  [SMALL_STATE(15)] = 860,
  [SMALL_STATE(16)] = 924,
  [SMALL_STATE(17)] = 988,
  [SMALL_STATE(18)] = 1052,
  [SMALL_STATE(19)] = 1116,
  [SMALL_STATE(20)] = 1180,
  [SMALL_STATE(21)] = 1244,
  [SMALL_STATE(22)] = 1308,
  [SMALL_STATE(23)] = 1375,
  [SMALL_STATE(24)] = 1440,
  [SMALL_STATE(25)] = 1503,
  [SMALL_STATE(26)] = 1565,
  [SMALL_STATE(27)] = 1693,
  [SMALL_STATE(28)] = 1755,
  [SMALL_STATE(29)] = 1815,
  [SMALL_STATE(30)] = 1877,
  [SMALL_STATE(31)] = 1936,
  [SMALL_STATE(32)] = 1995,
  [SMALL_STATE(33)] = 2054,
  [SMALL_STATE(34)] = 2145,
  [SMALL_STATE(35)] = 2208,
  [SMALL_STATE(36)] = 2267,
  [SMALL_STATE(37)] = 2326,
  [SMALL_STATE(38)] = 2385,
  [SMALL_STATE(39)] = 2444,
  [SMALL_STATE(40)] = 2513,
  [SMALL_STATE(41)] = 2576,
  [SMALL_STATE(42)] = 2635,
  [SMALL_STATE(43)] = 2694,
  [SMALL_STATE(44)] = 2757,
  [SMALL_STATE(45)] = 2816,
  [SMALL_STATE(46)] = 2879,
  [SMALL_STATE(47)] = 2938,
  [SMALL_STATE(48)] = 3001,
  [SMALL_STATE(49)] = 3064,
  [SMALL_STATE(50)] = 3123,
  [SMALL_STATE(51)] = 3186,
  [SMALL_STATE(52)] = 3249,
  [SMALL_STATE(53)] = 3308,
  [SMALL_STATE(54)] = 3367,
  [SMALL_STATE(55)] = 3426,
  [SMALL_STATE(56)] = 3485,
  [SMALL_STATE(57)] = 3544,
  [SMALL_STATE(58)] = 3603,
  [SMALL_STATE(59)] = 3662,
  [SMALL_STATE(60)] = 3721,
  [SMALL_STATE(61)] = 3780,
  [SMALL_STATE(62)] = 3842,
  [SMALL_STATE(63)] = 3904,
  [SMALL_STATE(64)] = 4023,
  [SMALL_STATE(65)] = 4142,
  [SMALL_STATE(66)] = 4257,
  [SMALL_STATE(67)] = 4370,
  [SMALL_STATE(68)] = 4479,
  [SMALL_STATE(69)] = 4555,
  [SMALL_STATE(70)] = 4659,
  [SMALL_STATE(71)] = 4715,
  [SMALL_STATE(72)] = 4831,
  [SMALL_STATE(73)] = 4887,
  [SMALL_STATE(74)] = 4943,
  [SMALL_STATE(75)] = 5013,
  [SMALL_STATE(76)] = 5087,
  [SMALL_STATE(77)] = 5151,
  [SMALL_STATE(78)] = 5211,
  [SMALL_STATE(79)] = 5281,
  [SMALL_STATE(80)] = 5339,
  [SMALL_STATE(81)] = 5395,
  [SMALL_STATE(82)] = 5451,
  [SMALL_STATE(83)] = 5507,
  [SMALL_STATE(84)] = 5623,
  [SMALL_STATE(85)] = 5679,
  [SMALL_STATE(86)] = 5735,
  [SMALL_STATE(87)] = 5791,
  [SMALL_STATE(88)] = 5847,
  [SMALL_STATE(89)] = 5903,
  [SMALL_STATE(90)] = 5961,
  [SMALL_STATE(91)] = 6039,
  [SMALL_STATE(92)] = 6095,
  [SMALL_STATE(93)] = 6151,
  [SMALL_STATE(94)] = 6207,
  [SMALL_STATE(95)] = 6263,
  [SMALL_STATE(96)] = 6341,
  [SMALL_STATE(97)] = 6397,
  [SMALL_STATE(98)] = 6510,
  [SMALL_STATE(99)] = 6623,
  [SMALL_STATE(100)] = 6736,
  [SMALL_STATE(101)] = 6849,
  [SMALL_STATE(102)] = 6962,
  [SMALL_STATE(103)] = 7072,
  [SMALL_STATE(104)] = 7176,
  [SMALL_STATE(105)] = 7286,
  [SMALL_STATE(106)] = 7396,
  [SMALL_STATE(107)] = 7500,
  [SMALL_STATE(108)] = 7601,
  [SMALL_STATE(109)] = 7702,
  [SMALL_STATE(110)] = 7781,
  [SMALL_STATE(111)] = 7882,
  [SMALL_STATE(112)] = 7956,
  [SMALL_STATE(113)] = 8054,
  [SMALL_STATE(114)] = 8149,
  [SMALL_STATE(115)] = 8222,
  [SMALL_STATE(116)] = 8303,
  [SMALL_STATE(117)] = 8398,
  [SMALL_STATE(118)] = 8493,
  [SMALL_STATE(119)] = 8588,
  [SMALL_STATE(120)] = 8683,
  [SMALL_STATE(121)] = 8778,
  [SMALL_STATE(122)] = 8873,
  [SMALL_STATE(123)] = 8968,
  [SMALL_STATE(124)] = 9041,
  [SMALL_STATE(125)] = 9136,
  [SMALL_STATE(126)] = 9231,
  [SMALL_STATE(127)] = 9326,
  [SMALL_STATE(128)] = 9407,
  [SMALL_STATE(129)] = 9488,
  [SMALL_STATE(130)] = 9569,
  [SMALL_STATE(131)] = 9661,
  [SMALL_STATE(132)] = 9739,
  [SMALL_STATE(133)] = 9817,
  [SMALL_STATE(134)] = 9909,
  [SMALL_STATE(135)] = 10001,
  [SMALL_STATE(136)] = 10093,
  [SMALL_STATE(137)] = 10185,
  [SMALL_STATE(138)] = 10277,
  [SMALL_STATE(139)] = 10369,
  [SMALL_STATE(140)] = 10461,
  [SMALL_STATE(141)] = 10553,
  [SMALL_STATE(142)] = 10631,
  [SMALL_STATE(143)] = 10723,
  [SMALL_STATE(144)] = 10815,
  [SMALL_STATE(145)] = 10893,
  [SMALL_STATE(146)] = 10985,
  [SMALL_STATE(147)] = 11077,
  [SMALL_STATE(148)] = 11169,
  [SMALL_STATE(149)] = 11261,
  [SMALL_STATE(150)] = 11353,
  [SMALL_STATE(151)] = 11445,
  [SMALL_STATE(152)] = 11537,
  [SMALL_STATE(153)] = 11629,
  [SMALL_STATE(154)] = 11721,
  [SMALL_STATE(155)] = 11813,
  [SMALL_STATE(156)] = 11905,
  [SMALL_STATE(157)] = 11997,
  [SMALL_STATE(158)] = 12075,
  [SMALL_STATE(159)] = 12167,
  [SMALL_STATE(160)] = 12259,
  [SMALL_STATE(161)] = 12337,
  [SMALL_STATE(162)] = 12429,
  [SMALL_STATE(163)] = 12507,
  [SMALL_STATE(164)] = 12599,
  [SMALL_STATE(165)] = 12691,
  [SMALL_STATE(166)] = 12783,
  [SMALL_STATE(167)] = 12861,
  [SMALL_STATE(168)] = 12939,
  [SMALL_STATE(169)] = 13017,
  [SMALL_STATE(170)] = 13095,
  [SMALL_STATE(171)] = 13187,
  [SMALL_STATE(172)] = 13265,
  [SMALL_STATE(173)] = 13343,
  [SMALL_STATE(174)] = 13421,
  [SMALL_STATE(175)] = 13513,
  [SMALL_STATE(176)] = 13588,
  [SMALL_STATE(177)] = 13663,
  [SMALL_STATE(178)] = 13738,
  [SMALL_STATE(179)] = 13813,
  [SMALL_STATE(180)] = 13888,
  [SMALL_STATE(181)] = 13963,
  [SMALL_STATE(182)] = 14038,
  [SMALL_STATE(183)] = 14113,
  [SMALL_STATE(184)] = 14188,
  [SMALL_STATE(185)] = 14263,
  [SMALL_STATE(186)] = 14338,
  [SMALL_STATE(187)] = 14413,
  [SMALL_STATE(188)] = 14488,
  [SMALL_STATE(189)] = 14563,
  [SMALL_STATE(190)] = 14638,
  [SMALL_STATE(191)] = 14713,
  [SMALL_STATE(192)] = 14788,
  [SMALL_STATE(193)] = 14863,
  [SMALL_STATE(194)] = 14938,
  [SMALL_STATE(195)] = 15013,
  [SMALL_STATE(196)] = 15088,
  [SMALL_STATE(197)] = 15163,
  [SMALL_STATE(198)] = 15238,
  [SMALL_STATE(199)] = 15313,
  [SMALL_STATE(200)] = 15388,
  [SMALL_STATE(201)] = 15463,
  [SMALL_STATE(202)] = 15538,
  [SMALL_STATE(203)] = 15613,
  [SMALL_STATE(204)] = 15688,
  [SMALL_STATE(205)] = 15763,
  [SMALL_STATE(206)] = 15838,
  [SMALL_STATE(207)] = 15913,
  [SMALL_STATE(208)] = 15988,
  [SMALL_STATE(209)] = 16063,
  [SMALL_STATE(210)] = 16138,
  [SMALL_STATE(211)] = 16184,
  [SMALL_STATE(212)] = 16228,
  [SMALL_STATE(213)] = 16281,
  [SMALL_STATE(214)] = 16347,
  [SMALL_STATE(215)] = 16397,
  [SMALL_STATE(216)] = 16459,
  [SMALL_STATE(217)] = 16507,
  [SMALL_STATE(218)] = 16552,
  [SMALL_STATE(219)] = 16593,
  [SMALL_STATE(220)] = 16634,
  [SMALL_STATE(221)] = 16675,
  [SMALL_STATE(222)] = 16716,
  [SMALL_STATE(223)] = 16755,
  [SMALL_STATE(224)] = 16796,
  [SMALL_STATE(225)] = 16837,
  [SMALL_STATE(226)] = 16877,
  [SMALL_STATE(227)] = 16913,
  [SMALL_STATE(228)] = 16951,
  [SMALL_STATE(229)] = 16991,
  [SMALL_STATE(230)] = 17027,
  [SMALL_STATE(231)] = 17067,
  [SMALL_STATE(232)] = 17103,
  [SMALL_STATE(233)] = 17140,
  [SMALL_STATE(234)] = 17194,
  [SMALL_STATE(235)] = 17228,
  [SMALL_STATE(236)] = 17262,
  [SMALL_STATE(237)] = 17296,
  [SMALL_STATE(238)] = 17330,
  [SMALL_STATE(239)] = 17364,
  [SMALL_STATE(240)] = 17422,
  [SMALL_STATE(241)] = 17456,
  [SMALL_STATE(242)] = 17510,
  [SMALL_STATE(243)] = 17544,
  [SMALL_STATE(244)] = 17578,
  [SMALL_STATE(245)] = 17612,
  [SMALL_STATE(246)] = 17646,
  [SMALL_STATE(247)] = 17680,
  [SMALL_STATE(248)] = 17714,
  [SMALL_STATE(249)] = 17748,
  [SMALL_STATE(250)] = 17782,
  [SMALL_STATE(251)] = 17816,
  [SMALL_STATE(252)] = 17850,
  [SMALL_STATE(253)] = 17884,
  [SMALL_STATE(254)] = 17918,
  [SMALL_STATE(255)] = 17952,
  [SMALL_STATE(256)] = 17986,
  [SMALL_STATE(257)] = 18020,
  [SMALL_STATE(258)] = 18054,
  [SMALL_STATE(259)] = 18088,
  [SMALL_STATE(260)] = 18142,
  [SMALL_STATE(261)] = 18176,
  [SMALL_STATE(262)] = 18210,
  [SMALL_STATE(263)] = 18244,
  [SMALL_STATE(264)] = 18278,
  [SMALL_STATE(265)] = 18312,
  [SMALL_STATE(266)] = 18346,
  [SMALL_STATE(267)] = 18380,
  [SMALL_STATE(268)] = 18414,
  [SMALL_STATE(269)] = 18448,
  [SMALL_STATE(270)] = 18482,
  [SMALL_STATE(271)] = 18516,
  [SMALL_STATE(272)] = 18550,
  [SMALL_STATE(273)] = 18589,
  [SMALL_STATE(274)] = 18644,
  [SMALL_STATE(275)] = 18677,
  [SMALL_STATE(276)] = 18729,
  [SMALL_STATE(277)] = 18781,
  [SMALL_STATE(278)] = 18833,
  [SMALL_STATE(279)] = 18885,
  [SMALL_STATE(280)] = 18937,
  [SMALL_STATE(281)] = 18989,
  [SMALL_STATE(282)] = 19041,
  [SMALL_STATE(283)] = 19075,
  [SMALL_STATE(284)] = 19127,
  [SMALL_STATE(285)] = 19179,
  [SMALL_STATE(286)] = 19231,
  [SMALL_STATE(287)] = 19283,
  [SMALL_STATE(288)] = 19335,
  [SMALL_STATE(289)] = 19387,
  [SMALL_STATE(290)] = 19418,
  [SMALL_STATE(291)] = 19449,
  [SMALL_STATE(292)] = 19502,
  [SMALL_STATE(293)] = 19546,
  [SMALL_STATE(294)] = 19584,
  [SMALL_STATE(295)] = 19610,
  [SMALL_STATE(296)] = 19648,
  [SMALL_STATE(297)] = 19672,
  [SMALL_STATE(298)] = 19710,
  [SMALL_STATE(299)] = 19746,
  [SMALL_STATE(300)] = 19784,
  [SMALL_STATE(301)] = 19822,
  [SMALL_STATE(302)] = 19848,
  [SMALL_STATE(303)] = 19886,
  [SMALL_STATE(304)] = 19919,
  [SMALL_STATE(305)] = 19946,
  [SMALL_STATE(306)] = 19967,
  [SMALL_STATE(307)] = 19995,
  [SMALL_STATE(308)] = 20029,
  [SMALL_STATE(309)] = 20057,
  [SMALL_STATE(310)] = 20085,
  [SMALL_STATE(311)] = 20113,
  [SMALL_STATE(312)] = 20141,
  [SMALL_STATE(313)] = 20166,
  [SMALL_STATE(314)] = 20186,
  [SMALL_STATE(315)] = 20204,
  [SMALL_STATE(316)] = 20232,
  [SMALL_STATE(317)] = 20260,
  [SMALL_STATE(318)] = 20282,
  [SMALL_STATE(319)] = 20304,
  [SMALL_STATE(320)] = 20324,
  [SMALL_STATE(321)] = 20352,
  [SMALL_STATE(322)] = 20372,
  [SMALL_STATE(323)] = 20392,
  [SMALL_STATE(324)] = 20412,
  [SMALL_STATE(325)] = 20432,
  [SMALL_STATE(326)] = 20452,
  [SMALL_STATE(327)] = 20477,
  [SMALL_STATE(328)] = 20502,
  [SMALL_STATE(329)] = 20527,
  [SMALL_STATE(330)] = 20552,
  [SMALL_STATE(331)] = 20575,
  [SMALL_STATE(332)] = 20600,
  [SMALL_STATE(333)] = 20619,
  [SMALL_STATE(334)] = 20644,
  [SMALL_STATE(335)] = 20669,
  [SMALL_STATE(336)] = 20688,
  [SMALL_STATE(337)] = 20713,
  [SMALL_STATE(338)] = 20738,
  [SMALL_STATE(339)] = 20763,
  [SMALL_STATE(340)] = 20782,
  [SMALL_STATE(341)] = 20803,
  [SMALL_STATE(342)] = 20828,
  [SMALL_STATE(343)] = 20847,
  [SMALL_STATE(344)] = 20864,
  [SMALL_STATE(345)] = 20883,
  [SMALL_STATE(346)] = 20906,
  [SMALL_STATE(347)] = 20929,
  [SMALL_STATE(348)] = 20954,
  [SMALL_STATE(349)] = 20979,
  [SMALL_STATE(350)] = 21004,
  [SMALL_STATE(351)] = 21029,
  [SMALL_STATE(352)] = 21054,
  [SMALL_STATE(353)] = 21075,
  [SMALL_STATE(354)] = 21100,
  [SMALL_STATE(355)] = 21125,
  [SMALL_STATE(356)] = 21150,
  [SMALL_STATE(357)] = 21175,
  [SMALL_STATE(358)] = 21200,
  [SMALL_STATE(359)] = 21220,
  [SMALL_STATE(360)] = 21242,
  [SMALL_STATE(361)] = 21262,
  [SMALL_STATE(362)] = 21282,
  [SMALL_STATE(363)] = 21300,
  [SMALL_STATE(364)] = 21322,
  [SMALL_STATE(365)] = 21342,
  [SMALL_STATE(366)] = 21362,
  [SMALL_STATE(367)] = 21382,
  [SMALL_STATE(368)] = 21402,
  [SMALL_STATE(369)] = 21424,
  [SMALL_STATE(370)] = 21440,
  [SMALL_STATE(371)] = 21456,
  [SMALL_STATE(372)] = 21472,
  [SMALL_STATE(373)] = 21492,
  [SMALL_STATE(374)] = 21508,
  [SMALL_STATE(375)] = 21524,
  [SMALL_STATE(376)] = 21542,
  [SMALL_STATE(377)] = 21558,
  [SMALL_STATE(378)] = 21574,
  [SMALL_STATE(379)] = 21592,
  [SMALL_STATE(380)] = 21608,
  [SMALL_STATE(381)] = 21626,
  [SMALL_STATE(382)] = 21646,
  [SMALL_STATE(383)] = 21666,
  [SMALL_STATE(384)] = 21682,
  [SMALL_STATE(385)] = 21698,
  [SMALL_STATE(386)] = 21718,
  [SMALL_STATE(387)] = 21740,
  [SMALL_STATE(388)] = 21756,
  [SMALL_STATE(389)] = 21772,
  [SMALL_STATE(390)] = 21792,
  [SMALL_STATE(391)] = 21808,
  [SMALL_STATE(392)] = 21828,
  [SMALL_STATE(393)] = 21844,
  [SMALL_STATE(394)] = 21864,
  [SMALL_STATE(395)] = 21880,
  [SMALL_STATE(396)] = 21900,
  [SMALL_STATE(397)] = 21920,
  [SMALL_STATE(398)] = 21940,
  [SMALL_STATE(399)] = 21956,
  [SMALL_STATE(400)] = 21972,
  [SMALL_STATE(401)] = 21988,
  [SMALL_STATE(402)] = 22004,
  [SMALL_STATE(403)] = 22020,
  [SMALL_STATE(404)] = 22036,
  [SMALL_STATE(405)] = 22052,
  [SMALL_STATE(406)] = 22068,
  [SMALL_STATE(407)] = 22088,
  [SMALL_STATE(408)] = 22108,
  [SMALL_STATE(409)] = 22128,
  [SMALL_STATE(410)] = 22148,
  [SMALL_STATE(411)] = 22170,
  [SMALL_STATE(412)] = 22192,
  [SMALL_STATE(413)] = 22212,
  [SMALL_STATE(414)] = 22232,
  [SMALL_STATE(415)] = 22252,
  [SMALL_STATE(416)] = 22272,
  [SMALL_STATE(417)] = 22290,
  [SMALL_STATE(418)] = 22306,
  [SMALL_STATE(419)] = 22326,
  [SMALL_STATE(420)] = 22345,
  [SMALL_STATE(421)] = 22364,
  [SMALL_STATE(422)] = 22383,
  [SMALL_STATE(423)] = 22400,
  [SMALL_STATE(424)] = 22417,
  [SMALL_STATE(425)] = 22436,
  [SMALL_STATE(426)] = 22455,
  [SMALL_STATE(427)] = 22472,
  [SMALL_STATE(428)] = 22491,
  [SMALL_STATE(429)] = 22506,
  [SMALL_STATE(430)] = 22523,
  [SMALL_STATE(431)] = 22542,
  [SMALL_STATE(432)] = 22559,
  [SMALL_STATE(433)] = 22578,
  [SMALL_STATE(434)] = 22595,
  [SMALL_STATE(435)] = 22614,
  [SMALL_STATE(436)] = 22631,
  [SMALL_STATE(437)] = 22650,
  [SMALL_STATE(438)] = 22669,
  [SMALL_STATE(439)] = 22688,
  [SMALL_STATE(440)] = 22705,
  [SMALL_STATE(441)] = 22724,
  [SMALL_STATE(442)] = 22743,
  [SMALL_STATE(443)] = 22762,
  [SMALL_STATE(444)] = 22781,
  [SMALL_STATE(445)] = 22798,
  [SMALL_STATE(446)] = 22815,
  [SMALL_STATE(447)] = 22834,
  [SMALL_STATE(448)] = 22853,
  [SMALL_STATE(449)] = 22872,
  [SMALL_STATE(450)] = 22891,
  [SMALL_STATE(451)] = 22908,
  [SMALL_STATE(452)] = 22927,
  [SMALL_STATE(453)] = 22946,
  [SMALL_STATE(454)] = 22965,
  [SMALL_STATE(455)] = 22984,
  [SMALL_STATE(456)] = 23003,
  [SMALL_STATE(457)] = 23022,
  [SMALL_STATE(458)] = 23041,
  [SMALL_STATE(459)] = 23060,
  [SMALL_STATE(460)] = 23074,
  [SMALL_STATE(461)] = 23090,
  [SMALL_STATE(462)] = 23106,
  [SMALL_STATE(463)] = 23120,
  [SMALL_STATE(464)] = 23134,
  [SMALL_STATE(465)] = 23148,
  [SMALL_STATE(466)] = 23162,
  [SMALL_STATE(467)] = 23175,
  [SMALL_STATE(468)] = 23188,
  [SMALL_STATE(469)] = 23201,
  [SMALL_STATE(470)] = 23214,
  [SMALL_STATE(471)] = 23227,
  [SMALL_STATE(472)] = 23240,
  [SMALL_STATE(473)] = 23253,
  [SMALL_STATE(474)] = 23266,
  [SMALL_STATE(475)] = 23279,
  [SMALL_STATE(476)] = 23292,
  [SMALL_STATE(477)] = 23305,
  [SMALL_STATE(478)] = 23318,
  [SMALL_STATE(479)] = 23331,
  [SMALL_STATE(480)] = 23344,
  [SMALL_STATE(481)] = 23357,
  [SMALL_STATE(482)] = 23370,
  [SMALL_STATE(483)] = 23383,
  [SMALL_STATE(484)] = 23396,
  [SMALL_STATE(485)] = 23409,
  [SMALL_STATE(486)] = 23422,
  [SMALL_STATE(487)] = 23435,
  [SMALL_STATE(488)] = 23448,
  [SMALL_STATE(489)] = 23461,
  [SMALL_STATE(490)] = 23474,
  [SMALL_STATE(491)] = 23487,
  [SMALL_STATE(492)] = 23500,
  [SMALL_STATE(493)] = 23513,
  [SMALL_STATE(494)] = 23526,
  [SMALL_STATE(495)] = 23539,
  [SMALL_STATE(496)] = 23552,
  [SMALL_STATE(497)] = 23565,
  [SMALL_STATE(498)] = 23578,
  [SMALL_STATE(499)] = 23591,
  [SMALL_STATE(500)] = 23604,
  [SMALL_STATE(501)] = 23617,
  [SMALL_STATE(502)] = 23630,
  [SMALL_STATE(503)] = 23643,
  [SMALL_STATE(504)] = 23656,
  [SMALL_STATE(505)] = 23669,
  [SMALL_STATE(506)] = 23682,
  [SMALL_STATE(507)] = 23695,
  [SMALL_STATE(508)] = 23708,
  [SMALL_STATE(509)] = 23721,
  [SMALL_STATE(510)] = 23734,
  [SMALL_STATE(511)] = 23747,
  [SMALL_STATE(512)] = 23760,
  [SMALL_STATE(513)] = 23773,
  [SMALL_STATE(514)] = 23786,
  [SMALL_STATE(515)] = 23799,
  [SMALL_STATE(516)] = 23812,
  [SMALL_STATE(517)] = 23825,
  [SMALL_STATE(518)] = 23838,
  [SMALL_STATE(519)] = 23851,
  [SMALL_STATE(520)] = 23864,
  [SMALL_STATE(521)] = 23877,
  [SMALL_STATE(522)] = 23890,
  [SMALL_STATE(523)] = 23903,
  [SMALL_STATE(524)] = 23916,
  [SMALL_STATE(525)] = 23929,
  [SMALL_STATE(526)] = 23942,
  [SMALL_STATE(527)] = 23955,
  [SMALL_STATE(528)] = 23968,
  [SMALL_STATE(529)] = 23981,
  [SMALL_STATE(530)] = 23994,
  [SMALL_STATE(531)] = 24007,
  [SMALL_STATE(532)] = 24020,
  [SMALL_STATE(533)] = 24033,
  [SMALL_STATE(534)] = 24046,
  [SMALL_STATE(535)] = 24059,
  [SMALL_STATE(536)] = 24072,
  [SMALL_STATE(537)] = 24085,
  [SMALL_STATE(538)] = 24098,
  [SMALL_STATE(539)] = 24111,
  [SMALL_STATE(540)] = 24124,
  [SMALL_STATE(541)] = 24128,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 0),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 0),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_index_expression, 3, 0, 25),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_index_expression, 3, 0, 25),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracket_index_expression, 4, 0, 25),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracket_index_expression, 4, 0, 25),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [55] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_expression, 1, 0, 0),
  [57] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_expression, 1, 0, 0),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string, 3, 0, 31),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_string, 3, 0, 31),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, 0, 11),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, 0, 11),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 1, 0, 0),
  [69] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 1, 0, 0),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [73] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [81] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 2, 0, 0),
  [85] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 2, 0, 0),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [89] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [91] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 6),
  [93] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 6),
  [95] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 7),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 7),
  [99] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quote_string, 2, 0, 15),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__quote_string, 2, 0, 15),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string, 2, 0, 0),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_string, 2, 0, 0),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_string, 3, 0, 13),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_string, 3, 0, 13),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quote_string, 3, 0, 30),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__quote_string, 3, 0, 30),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 3, 0, 0),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 3, 0, 0),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_type, 2, 0, 0),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_type, 2, 0, 0),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(523),
  [138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_type, 2, 0, 0),
  [140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_type, 2, 0, 0),
  [142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3, 0, 0),
  [168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 44),
  [170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 44),
  [172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 0),
  [200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 0),
  [202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2, 0, 0),
  [208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_type, 2, 0, 0),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4, 0, 0),
  [212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4, 0, 0),
  [214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 4, 0, 0),
  [216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 4, 0, 0),
  [218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 5, 0, 44),
  [220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 5, 0, 44),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 0),
  [224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 0),
  [226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5, 0, 0),
  [228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5, 0, 0),
  [230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 6, 0, 0),
  [236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 6, 0, 0),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6, 0, 0),
  [240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6, 0, 0),
  [242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 7, 0, 0),
  [244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 7, 0, 0),
  [246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 7, 0, 0),
  [248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 7, 0, 0),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 8, 0, 0),
  [252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 8, 0, 0),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 9, 0, 0),
  [256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 9, 0, 0),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 10, 0, 0),
  [260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 10, 0, 0),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 11, 0, 0),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 11, 0, 0),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 0),
  [268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 0),
  [270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3, 0, 0),
  [272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3, 0, 0),
  [274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 3, 0, 0),
  [276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 3, 0, 0),
  [278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 5, 0, 0),
  [280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 5, 0, 0),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(135),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 3, 0, 34),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1, 0, 0),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0),
  [303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(2),
  [306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0),
  [308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(245),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(251),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(101),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(134),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(97),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(154),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(364),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(386),
  [335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(159),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 33),
  [346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 33),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, 0, 29),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, 0, 29),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil, 1, 0, 0),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil, 1, 0, 0),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, 0, 45),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 3, 0, 45),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, 0, 14),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, 0, 14),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 4, 0, 29),
  [406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 4, 0, 29),
  [408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 4, 0, 59),
  [410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 4, 0, 59),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 17),
  [414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 17),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 65),
  [418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 65),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 6, 0, 44),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 6, 0, 44),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 5, 0, 66),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 5, 0, 66),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 5, 0, 46),
  [430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 5, 0, 46),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 6, 0, 70),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 6, 0, 70),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 4, 0, 44),
  [438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 44),
  [440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, 0, 46),
  [442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 3, 0, 46),
  [444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 1, 0, 0),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 2, 0, 0),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 1, 0, 0),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 3, 0, 0),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 1, 0, 16),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 1, 0, 16),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 2, 0, 0),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 57),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 57),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 4, 0, 35),
  [484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 4, 0, 35),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 3, 0, 20),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 3, 0, 20),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 3, 0, 4),
  [576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 3, 0, 4),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 1, 0, 0),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 1, 0, 0),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 1, 0, 4),
  [594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 1, 0, 4),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0),
  [600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 4, 0, 27),
  [604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 4, 0, 27),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 27),
  [608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 27),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 2, 0, 23),
  [614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 2, 0, 23),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 2, 0, 22),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 2, 0, 22),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 3, 0, 40),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 3, 0, 40),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 5, 0, 64),
  [626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 5, 0, 64),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41),
  [632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41), SHIFT_REPEAT(538),
  [635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 4, 0, 54),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 4, 0, 54),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 4, 0, 55),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 4, 0, 55),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 56),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 56),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attrib, 3, 0, 0),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attrib, 3, 0, 0),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 58),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 58),
  [655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 58), SHIFT_REPEAT(147),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 2, 0, 43),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 2, 0, 43),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 5, 0, 69),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 5, 0, 69),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 27),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 27),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 3, 0, 53),
  [672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 3, 0, 53),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 10),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 10),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, 0, 67),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_statement, 3, 0, 24),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_statement, 3, 0, 24),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 60),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 60),
  [690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 61),
  [692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 61),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 62),
  [696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 62),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 48),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 48),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 44),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 44),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, 0, 16),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 49),
  [712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 49),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 50),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 50),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 68),
  [720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 68),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 52),
  [728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 52),
  [730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 7, 0, 27),
  [732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 7, 0, 27),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 8, 0, 56),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 8, 0, 56),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 2, 0, 0),
  [740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 2, 0, 0),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 2),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 2),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 1, 0, 0),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 1, 0, 0),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 1),
  [752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 1),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 34),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 34),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 34),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 34),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 21),
  [768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 21),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, 0, 47),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 24),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, 0, 24),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 37),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, 0, 37),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 4, 0, 39),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_function_declaration, 4, 0, 39),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_variable_assignment, 3, 0, 42),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_variable_assignment, 3, 0, 42),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 3, 0, 19),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 3, 0, 19),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 3),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 3),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 1, 0, 4),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 5, 0, 63),
  [808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_sep, 1, 0, 0),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_sep, 1, 0, 0),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 7, 0, 71),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 27),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(133),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 28),
  [887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 28), SHIFT_REPEAT(303),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(324),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(150),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(325),
  [903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(325),
  [906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(313),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 2, 0, 12),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 2, 0, 0),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 2, 0, 0),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__escape_sequence, 1, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__escape_sequence, 1, 0, 0),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_index_expression, 3, 0, 26),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 18),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 18),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(494),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 0),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 0),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 0),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolation_string_content, 1, 0, 0),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolation_string_content, 1, 0, 0),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 1, 0, 0),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [1037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2, 0, 0),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51),
  [1045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51), SHIFT_REPEAT(151),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1, 0, 0),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [1100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 4, 0, 0),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 4, 0, 0),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_list, 1, 0, 4),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 0),
  [1112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1, 0, 0),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 2, 0, 0),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 2, 0, 0),
  [1118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__doublequote_string_content, 2, 0, 0),
  [1120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__doublequote_string_content, 2, 0, 0), SHIFT_REPEAT(433),
  [1123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__singlequote_string_content, 2, 0, 0),
  [1125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__singlequote_string_content, 2, 0, 0), SHIFT_REPEAT(423),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1, 0, 8),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(176),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_dot_index_expression, 3, 0, 25),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, 0, 0),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 2, 0, 0),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__singlequote_string_content, 1, 0, 0),
  [1169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__singlequote_string_content, 1, 0, 0),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 2, 0, 0), SHIFT_REPEAT(506),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 2, 0, 0),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 1, 0, 0),
  [1184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_type_list_repeat1, 2, 0, 0), SHIFT_REPEAT(515),
  [1187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_type_list_repeat1, 2, 0, 0),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0), SHIFT_REPEAT(443),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__doublequote_string_content, 1, 0, 0),
  [1200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__doublequote_string_content, 1, 0, 0),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_statement, 4, 0, 44),
  [1206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 4, 0, 44),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_list, 2, 0, 12),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 36),
  [1214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 36),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(460),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0),
  [1227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(199),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, 0, 28), SHIFT_REPEAT(484),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, 0, 28),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, 0, 9),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_method_index_expression, 3, 0, 26),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, 0, 27),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 4, 0, 0),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 3, 0, 0),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1287] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 2, 0, 19),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 3, 0, 0),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_list, 3, 0, 0),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_field_type, 3, 0, 0),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_generic_clause, 3, 0, 38),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_list, 4, 0, 0),
  [1389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, 0, 5),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 3, 0, 13),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__block_comment_start = 0,
  ts_external_token__block_comment_content = 1,
  ts_external_token__block_comment_end = 2,
  ts_external_token__block_string_start = 3,
  ts_external_token__block_string_content = 4,
  ts_external_token__block_string_end = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__block_comment_start] = sym__block_comment_start,
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__block_comment_end] = sym__block_comment_end,
  [ts_external_token__block_string_start] = sym__block_string_start,
  [ts_external_token__block_string_content] = sym__block_string_content,
  [ts_external_token__block_string_end] = sym__block_string_end,
};

static const bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__block_comment_end] = true,
    [ts_external_token__block_string_start] = true,
    [ts_external_token__block_string_content] = true,
    [ts_external_token__block_string_end] = true,
  },
  [2] = {
    [ts_external_token__block_comment_start] = true,
  },
  [3] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_start] = true,
  },
  [4] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_end] = true,
  },
  [5] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_end] = true,
  },
  [6] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
  },
  [7] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_luau_external_scanner_create(void);
void tree_sitter_luau_external_scanner_destroy(void *);
bool tree_sitter_luau_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_luau_external_scanner_serialize(void *, char *);
void tree_sitter_luau_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_luau(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_luau_external_scanner_create,
      tree_sitter_luau_external_scanner_destroy,
      tree_sitter_luau_external_scanner_scan,
      tree_sitter_luau_external_scanner_serialize,
      tree_sitter_luau_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
